var asterisk_guifbt = 300; // Feedback msg time

function getDocHeight(D) {
    return Math.max(
        Math.max(D.body.scrollHeight, D.documentElement.scrollHeight),
        Math.max(D.body.offsetHeight, D.documentElement.offsetHeight),
        Math.max(D.body.clientHeight, D.documentElement.clientHeight)
    );
}

_$ = function(x){
	if ( typeof x != 'string' ){ return null ;}
	try{
		return document.getElementById(x); 
	}catch(err){ return null; }
};

// Some custom methods to Array Objects
	Array.prototype.replaceAB = function(a, b) { // return new array with all instances of a replaced with b
		var x =[];
		for(var i=0, j = this.length ; i < j; i++ ){
			if( this[i] === a ){
				x.push(b);
			}else{
				x.push(this[i]);
			}
		}
		return x;
	};

	Array.prototype.lastValue = function(){
		// [0,1,2]
		return (this.length)? this[this.length - 1] : null;
	};

	Array.prototype.replaceLastWith = function(a){
		if( this.length )
			this[this.length - 1] = a ;
	}

	Array.prototype.contains = function(str) {
		return this.indexOf(str) != -1 ;
	};

	Array.prototype.containsLike = function(str) {
		return this.indexOfLike(str) != -1;
	};
	
	Array.prototype.each = function(iterator) {
		for(var i=0 , j = this.length; i < j ; i++ ){
			iterator(this[i] , i);
		}
	};

	Array.prototype.forEach = function(iterator) { // call a function on each element and update the element with the returned value
		var i = this.length;
		while (i--) {

			this[i] = iterator(this[i] , i);
		}
	};
	
	Array.prototype.firstAvailable = function(start) {
		if(!start){ start = 1; }else{ start = Number( start ); }
		if(!this.length){return start;}
		for(var y=0, x=[] ; y< this.length; y++){ x.push( Number(this[y]) ); } // 'this' can also be an array of number strings
		var i=0;
		while( i < 1 ){
			if( x.contains(start) ){ start++; }else{ return start; }
		}
	};

	Array.prototype.removeFirst = function(){ // opposite of push - removes the first element of the array
		this.splice(0,1);
	};
	
	if(!Array.indexOf){
		Array.prototype.indexOf = function(a){
			var i = this.length;
			while (i--) {

				if( this[i] === a ){
					return i;
				}
			}
			return -1;
		}
	}

	Array.prototype.indexOfLike = function( searchString ){
		if(!searchString.length){ return -1; }
		for(var i=0; i < this.length; i++ ){ if( this[i].beginsWith(searchString) ){ return i ; } }
		return -1 ;
	};

	Array.prototype.lastIndexOfLike = function( searchString ){
		if(!searchString.length){ return -1;}
		var i = this.length;
		while (i--) {
			if( typeof this[i] == 'string' && this[i].beginsWith(searchString) ){ return i; }
		}
		return -1 ;
	};

	Array.prototype.push_IfNotPresent = function( a ){
		if(!this.contains(a)) this.push(a);
	};
	
	Array.prototype.sortNumbers = function() {
		return this.sort(function(a,b){return a - b});
	};
	
	Array.prototype.withOut = function(e) {
		var x =[];
		if( typeof e == 'string' || typeof e == 'number' ){
			var y = [e];
		}else if( e instanceof Array ){
			var y = e;
		}else{
			return this;
		}

		for( var a =0 ; a < y.length ; a++ ){
			var b = y[a];
			for( var i=0, j=this.length ; i < j ; i++ ){
				if( !(this[i] === b) && !y.contains(this[i]) && !x.contains(this[i]) ){
					x.push(this[i]);
				}
			}
		}

		return x ;
	};

// String Manipulation, and other custom methods for String Objects
	String.prototype.addZero = function(){
		return ( Number(this) < 10)? "0" + this : this;
	};

	String.prototype.afterChar = function(k){
		if(k.length > 1){ alert('String.afterChar() should be used with a single character'); return null;}
		var v = this.indexOf(k);
		if( v == -1){ return ''; }
		return this.substring(v+1);
	};

	String.prototype.afterStr = function(x){
		if( !this.contains(x) ){ return ''; }
		if(x.length == 1){ return this.afterChar(x); }
		var pos = this.indexOf(x) + x.length ;
		return this.substr(pos);
	};

	String.prototype.beforeChar = function(k){
		if(k.length > 1){ 
			alert('String.beforeChar() should be used with a single character');
			return null;
		}
		var v = this.indexOf(k);
		if( v == -1){ return ''; }
		return this.substring(0,v);
	};

	String.prototype.beforeStr = function(x){
		var r = this.afterStr(x);
		return this.withOut(x+r);
	};

	String.prototype.beginsWith = function(a){
		return this.length>=a.length && this.substring(0,a.length)==a
	};

	String.prototype.betweenXY = function(X,Y){
		if(X.length > 1 || Y.length > 1){ alert('String.betweenXY() accepts single character arguments'); return null;}
		var t = this.afterChar(X);
		return t.beforeChar(Y);
	};

	String.prototype.bold_X = function(x){
		if(x==''){return this ;}
		var position = this.toLowerCase().indexOf( x.toLowerCase() ) ;
		if (position == -1){ return this; }
		var c = this.substr( position , x.length );
		return  this.replace( c, "<b>" + c + "</b>" , "" );
	};
	
	String.prototype.camelize = function(){
	    var parts = this.split(' '), len = parts.length;
		var camelized = '';
	    for (var i = 0; i < len; i++)
	      camelized += parts[i].charAt(0).toUpperCase() + parts[i].substring(1) + ' ';
	    return camelized;
	};

	String.prototype.capitalizeFirstChar = function() {
		return this.charAt(0).toUpperCase() + this.substring(1).toLowerCase();
	};

	String.prototype.contains=function(a){
		return this.indexOf(a)!=-1;
	};

	String.prototype.endsWith=function(a){
		return this.length >= a.length && this.substring(this.length-a.length)==a
	};

	String.prototype.escapeHTML = function() {
		var a = document.createTextNode(this);
		var b = document.createElement('div');
		b.appendChild(a);
		return b.innerHTML;
	};

	String.prototype.isAstTrue = function () {
		//return ( this == 'yes' || this == 'true' || this == 'y' || this == 't' || this == '1' || this == 'on' ) ? true : false;
		return ["yes", "true", "y", "t", "1", "on"].contains(this.toLowerCase().trim());
	};

	String.prototype.getNoOp = function(){
		return ( this.toLowerCase().indexOf('noop(') == -1 ) ? '' : this.betweenXY('(',')') ; // todo: handle multiple ')'s
	};

	String.prototype.guiMetaData = function(){
		return this + ' ; GUI metadata';
	};

	String.prototype.isValueInBetween = function (a,b) {
		a = Number(a);
		b = Number(b);
		var c = Number(this) , a1 = Math.min(a,b) , b1 = Math.max(a,b);
		return ( c >= a1 && c <= b1 ) ? true : false ;
	};

	String.prototype.lChop = function(c){ // chop a string from the beginning of the string
		if(this.beginsWith(c)){
			return this.substr(c.length);
		}
		return this;
	};

	String.prototype.rChop = function(c){ // chop a string from the end of the string
		if( this.indexOf(c) == -1 || !this.endsWith(c) ){
			return String(this); //actually we should be doing 'return this;' but for some reason firebug is reporting the returned string as an object
		}
		return this.substr( 0, this.length - c.length);
	};

	String.prototype.replaceXY = function(X,Y){
		return this.split(X).join(Y);
	};

	String.prototype.strip = function(){
		try {
			return this.replace(/^\s+|\s+$/g, "");
		} catch(e) {
			return s;
		}
	};

	String.prototype.times = function(a){
		return ( a < 1 ) ? '' : new Array(a+1).join(this);
	};

	String.prototype.stripTags = function() {
		return this.replace(/<\/?[^>]+>/gi, '');
	}

	String.prototype.trim = function(){ // alias to strip
		return this.strip();
	};

	String.prototype.withOut = function(k){
		return this.split(k).join('');
	};


Number.prototype.addZero = function(){
	return ( this < 10)? "0" + String(this) : String(this);
};

Number.prototype.isValueInBetween = function (a,b) {
	a = Number(a);
	b = Number(b);
	var a1 = Math.min(a,b) , b1 = Math.max(a,b);
	return ( this >= a1 && this <= b1 ) ? true : false ;
};

Number.prototype.guiMetaData = function(){
	return String(this) + ' ; GUI metadata';
};

var CheckForValidLogin = function(){
	try{
		ASTGUI.dialog.hide(); // if left open by last page hide
		var s = $.ajax({ url: ASTGUI.paths.rawman+'?action=ping', async: false });
		if(s.responseText.toLowerCase().match('pong')){ return true; }else{ return false; };
	}catch(err){ return false; }
}

// The ASTGUI Object - global varibles and various core GUI component functions
var ASTGUI = {
	includeContexts: {}, // updated below

	startDrag : function(event, movethis ){

		var initialcursorX, initialcursorY, initialwindowleft, initialwindowtop, maxleft, maxtop ;

		var stopDrag = function(){

			ASTGUI.events.remove( document , "mousemove" , movewindow ) ;

			ASTGUI.events.remove( document , "mouseup" , stopDrag ) ;

		};

		var movewindow = function(event){

			var x,y;

			if(typeof window.scrollX != "undefined"){

			x = event.clientX + window.scrollX;

			y = event.clientY + window.scrollY;

			}else{

				x =  window.event.clientX + document.documentElement.scrollLeft + document.body.scrollLeft;

				y = window.event.clientY + document.documentElement.scrollTop + document.body.scrollTop;

			}

			var tmp_top = initialwindowtop  + y - initialcursorY ; 

			var tmp_left = initialwindowleft + x - initialcursorX;

			if( tmp_left > 0 && tmp_left < maxleft ){ _$(movethis).style.left = tmp_left + "px"; }

			if( tmp_top > 0 && tmp_top < maxtop ){ _$(movethis).style.top  = tmp_top + "px"; }

		};

	

		if(typeof window.scrollX != "undefined"){

			initialcursorX = event.clientX + window.scrollX;

			initialcursorY = event.clientY + window.scrollY;

		}else{

			initialcursorX =  window.event.clientX + document.documentElement.scrollLeft + document.body.scrollLeft;

			initialcursorY = window.event.clientY + document.documentElement.scrollTop + document.body.scrollTop;

		}

	

		initialwindowleft = parseInt( _$(movethis).style.left ,10 ) ;

		initialwindowtop = parseInt(_$(movethis).style.top ,10) ;

	

		if(typeof window.innerWidth != "undefined"){

			maxleft = window.innerWidth - parseInt(_$(movethis).style.width , 10) ;

			maxtop = window.innerHeight - parseInt(_$(movethis).style.height , 10) ;

		}else{

			maxleft = document.body.offsetWidth - parseInt(_$(movethis).style.width , 10) ;

			maxtop = document.body.offsetWidth- parseInt(_$(movethis).style.height , 10) ;

		}

		ASTGUI.events.add( document , "mousemove" , movewindow ) ;

		ASTGUI.events.add( document , "mouseup" , stopDrag ) ;

	},

	globals: {
		lang : 'en',
		GUI_DB : 'astgui', // name of the ASTDB database used by GUI -- ASTGUI.globals.GUI_DB
		configfile : 'guipreferences.conf', // will be created if the file does not exist , ASTGUI.globals.configfile
		networkingfile : 'rc_org.conf', // will be created if the file does not exist , ASTGUI.globals.configfile
		hwcfgFile : 'gui_confighw.conf', // file to store configured hardware information
		dahdiIncludeFile: 'dahdi_guiRead.conf', // file that will be used to read zapte.conf, ASTGUI.globals.dahdiIncludeFile
		pingInterval : 10000,
		phoneVersion : 1000,
		administrator : 'admin',
		billing : 'billing',
		operator : 'operator',
		app_factoryReset : 'gzip -dc defaults.tgz | tar xvf -', // ASTGUI.globals.app_factoryReset
		fnf : 'ERROR:FNF',
		obcidstr : 'GLOBAL_OUTBOUNDCID', // ASTGUI.globals.obcidstr
		obcidUsrPrefix : 'CID_', // ASTGUI.globals.obcidUsrPrefix
		sbcid_1 : 's,1,ExecIf($[ "${CALLERID(num)}"="" ],SetCallerPres,unavailable)', // ASTGUI.globals.sbcid_1
		sbcid_2 : 's,2,ExecIf($[ "${CALLERID(num)}"="" ],Set,CALLERID(all)=unknown <0000000>)',
		timeservers: [ 'north-america.pool.ntp.org', 'asia.pool.ntp.org', 'europe.pool.ntp.org', 'oceania.pool.ntp.org', 'south-america.pool.ntp.org' ],
		dhcpd: { installed: false, enabled: false },
		dyndns: { installed: false, enabled: false }
	},

	contexts: {
		guitools : 'asterisk_guitools', // gui tools context
		dialtrunks : 'trunkdial-failover', // trunkdial macro with failback trunk and setcid, ASTGUI.contexts.dialtrunks
		CONFERENCES : 'conferences', // ASTGUI.contexts.CONFERENCES
		QUEUES : 'queues', //ASTGUI.contexts.QUEUES
		GLOBALS : 'globals',
		Featurecodes : 'featurecodes',
		TrunkDIDPrefix : 'DID_', // context for trunks -  - ASTGUI.contexts.TrunkDIDPrefix
		SIPBindaddr : '0.0.0.0:', 
		TrunkDefaultSuffix : '_default', // ASTGUI.contexts.TrunkDefaultSuffix - to create 'DID_trunk_default' that will be included in [DID_trunk]
		Default: 'default', // ASTGUI.contexts.Default 
		Voicemail: 'Voicemail', // ASTGUI.contexts.Voicemail 
		Hangup: 'Hangup', // ASTGUI.contexts.Hangup 
		Congestion: 'Congestion',
		RingGroupPrefix: 'ringroups-custom-', // ASTGUI.contexts.RingGroupPrefix 
		RingGroupExtensions: 'ringgroups', // ASTGUI.contexts.RingGroupExtensions
		TimeBasedRulePrefix: 'timebasedrule-custom-', // ASTGUI.contexts.TimeBasedRulePrefix 
		TimeIntervalPrefix: 'timeinterval_', // ASTGUI.contexts.TimeIntervalPrefix
		VoiceMenuPrefix: 'voicemenu-custom-', // ASTGUI.contexts.VoiceMenuPrefix
		DISAPrefix: 'disa-custom-',
		IVRExtensions: 'ivr', // ASTGUI.contexts.IVRExtensions
		Directory: 'directory', // ASTGUI.contexts.Directory
		Intercom: 'intercom', // ASTGUI.contexts.Intercom
		Paging: 'paging', // ASTGUI.contexts.Paging
		CallingRulePrefix : 'CallingRule_', // context for calling rules being with - ASTGUI.contexts.CallingRulePrefix 
		CallingPlanPrefix: 'DLPN_', // context for DialPlans -- ASTGUI.contexts.CallingPlanPrefix
		FaxPrefix: 'FAX_', // context for Faxes -- ASTGUI.contexts.FaxPrefix
		FaxTrunkPrefix: 'FAX_Trunk_', // context for Faxes -- ASTGUI.contexts.FaxTrunkPrefix
		FaxPSTNPrefix: 'FAX_PSTN_', // context for Faxes -- ASTGUI.contexts.FaxPSTNPrefix
		AnalogLabelPrefix: 'Analog_Port_',
		Fax: 'fax',
		Spy: 'spy',
		mohdirPrefix : 'guimohdir_', // ASTGUI.contexts.mohdirPrefix
		IncomingDirect : 'direct-',
		IncomingAnalog : 'macro-analog-custom-',
		IncomingVoip : 'custom-did-voip',
		IncomingDOD : 'custom-dod',
		BlackList: 'blacklist',
		DND: 'DND',
		DISAExtensions: 'disa', // ASTGUI.contexts.DISAExtensions
		PagingPrefix: 'paging-custom-',
		PagingExtensions: 'paging-intercom', // ASTGUI.contexts.PagingExtensions
		PhoneBook: 'cidname',
		SpeedDial: 'speeddial',
		Callback: 'callback',
		smartdcid: 'smart-dcid',
		MobileExten: 'mobileexten',
		PlayInvalid:'Background(invalid)'
		// music on hold directories created by gui will have this prefix
		// also post_mappings definitions in http.conf will have this name
	},
	manufacturers:{
		Zycoo: {
			types:['D30','D60'],
			mac:'00a859'},
//		DLink: 'DPH150,DPH400',
		Grandstream: {
			types:['GXP280','GXP1100','GXP1160','GXP1200','GXP1400','GXP1450','GXP2100','GXP2110','GXP2120','GXP2124'],
			mac:'000b82'},
		Yealink: {
			types:['T18','T20','T22','T26','T28','T32','T38','VP530'],
			mac:'001565'},
		Escene: {
			types:['HS108','HS118','CC800','US102','ES220','ES290','ES292','ES320','ES330','ES410','ES620','Others'],
			mac:'00268b'},
		AkuVox: {
			types:['R21','R23','R25','R27','R50','R51','R52','R53','R59'],
			mac:'0c1105'},
		Hanlong: {
			types:['UC860P','UC842','UC802P','UC840P','UC804P','UC806P'],
			mac:'001fc1'},
		Cisco: {
			types:['SPA303'],
			mac:'3cce73'},
		MOCET: {
			types:['IP3032E'],
			mac:'001915'}
	},
	voiceprompts:{
		en:'English *',
		cn:'中文',
		fr:'Français',
		es:'Español',
		pt_BR:'Português(Brasil)',
		it:'Italiano',
		farsi:'فارسی',
		ar:'العربية',
		tr:'Türk',
		th:'ประเทศไทย',
		ru:'Pусский',
		pt:'Português',
		pl:'Polska',
		nl:'Nederland',
		kr:'한국의',
		hu:'Magyarország',
		he:'עברית',
		gr:'Ελληνική',
		fr_CA:'Français(Canada)',
		es_MX:'Español(México)',
		de:'Deutschland'
	},
	errorCodes:{
		'AG101':'Aborting Upload : Action not defined for upload Form <br />' + 
			'Please set the Form action in the parent page via onUploadForm_beforeUploading()',
		'AG102':'Disabling all Upload forms in the gui: <br />' +
			'Either post_mappings or post_mappings->uploads is not defined in http.conf',
		'AG150':' SyncActions being used for more than 5 actions'
	},

	ASTDB:{
		updateKey : function( k ){ // ASTGUI.ASTDB.updateKey( { dbname: 'astgui', key : 'keyname', keyvalue : 'keyvalue' } );
			// k = { dbname: 'astgui', key : 'keyname', keyvalue : 'keyvalue' } // dbname is optional, defaults to ASTGUI.globals.GUI_DB
			if( !k.hasOwnProperty('dbname') ){
				k.dbname = ASTGUI.globals.GUI_DB ;
			}

			var s = ASTGUI.cliCommand('database put '+ k.dbname + ' ' + k.key + ' ' + k.keyvalue );
			if(s.contains('successfully')) return true;
			return false;
		},

		deleteKey : function( k ){ // ASTGUI.ASTDB.deleteKey( { dbname: 'astgui', key : 'keyname' } );
			// k = { dbname: 'astgui', key : 'keyname' } // dbname is optional, defaults to ASTGUI.globals.GUI_DB
			if( !k.hasOwnProperty('dbname') ){
				k.dbname = ASTGUI.globals.GUI_DB ;
			}

			var s = ASTGUI.cliCommand('database del '+ k.dbname + ' ' + k.key);
			if(s.contains('entry removed')) return true;
			return false;
		},


		getKey : function(k){  // ASTGUI.ASTDB.getKey( { dbname: 'astgui', key : 'keyname' } );
			// k = { dbname: 'astgui', key : 'keyname' } // dbname is optional, defaults to ASTGUI.globals.GUI_DB
			if( !k.hasOwnProperty('dbname') ){
				k.dbname = ASTGUI.globals.GUI_DB ;
			}

			var s = ASTGUI.cliCommand('database get '+ k.dbname + ' ' + k.key);
			if( s.contains('entry not found')) return null;
			var op = ASTGUI.parseCLIResponse( s );
			op = op.trim();
			op = op.withOut('Value:')
			return op.trim();
		},

		getAllKeys : function(k){ // ASTGUI.ASTDB.getAllKeys( { dbname: 'astgui' } );
			// k = { dbname: 'astgui' } // dbname is optional, defaults to ASTGUI.globals.GUI_DB
			if( !k.hasOwnProperty('dbname') ){
				k.dbname = ASTGUI.globals.GUI_DB ;
			}

			var db_keys = {};
			var tmp_dbpath = '/' + k.dbname + '/' ;
			var s = ASTGUI.cliCommand('database show '+ k.dbname);

			if(s.contains('entry not found')) return null;
			var op = ASTGUI.parseCLIResponse( s );
			if( op.trim() == ''){ return {}; }

			var tmp_lines = op.trim().split('\n');
			tmp_lines.each( function(this_line){
				if(this_line.contains(k.dbname)){
					var this_line = this_line.withOut(tmp_dbpath);
					var this_key = this_line.beforeChar(':').trim();
					var this_keyVal = this_line.afterChar(':').trim();
					db_keys[ this_key ] =  this_keyVal ;
				}
			});

			return db_keys;
		}
	},

	checkRequiredFields: function( fields ){
		for(var g=0; g < fields.length ; g++ ){
			var field = fields[g];
			if(typeof field =='string'){
				field = _$(field); 
			}
		
			var required = field.getAttributeNode('required');
			if( required ){
				var x = field.value.trim() ;
				var pcn = ( field.className ) ? field.className : '' ;
				if( !x ){
					ASTGUI.feedback( { msg:RequiredField, showfor:3 } );
					field.className = 'inputValidationFailed';
					setTimeout( function(){ field.className = pcn ; } , 4000 );
					try{ field.focus(); }catch(e){}
					return false;
				}
			}
		}
		return true;
	},

	cliCommand : function(cmd) { // ASTGUI.cliCommand(cmd);
		ASTGUI.Log.Debug("Executing manager command : '" + cmd + "'" );
		return makeSyncRequest ( { action :'command', command: cmd } );
	},

	cliCommandCallBack: function(cmd, callbackfunction){ // ASTGUI.cliCommandCallBack(cmd, cbf);
		ASTGUI.Log.Debug("Executing CLI Command : '" + cmd + "'" );
		var delay_cb = function(){
			if( top.sessionData.PLATFORM.isZX100 ){
				callbackfunction();
			} else {
				setTimeout( callbackfunction , 1000 );
			}
		};
		makeRequest ( { action :'command', command: cmd, callback:callbackfunction() } );
	},

	getUser_DeviceStatus : function( usr ){ // ASTGUI.getUser_DeviceStatus(usr) 
		var t = makeSyncRequest({ action :'ExtensionState', Exten: usr }) ;
		if( t.contains('Status: 0') ) return 'F' ; // No Device is Busy/InUse
		if( t.contains('Status: 1') ) return 'B' ; // 1 or more devices InUse
		if( t.contains('Status: 2') ) return 'B' ; // All Devices Busy
		if( t.contains('DAHDI') && t.contains('Status: 4') ) return 'F' //FXS extension
		if( t.contains('Status: 4') ) return 'U' ; // All Devices Unavailable/Unregistered
		if( t.contains('Status: 8') ) return 'R' ; // All Devices Ringing
		return null;
	},

	getUser_DeviceStatus_Image : function( usr ){ // ASTGUI.getUser_DeviceStatus_Image(usr) 
		var s =  this.getUser_DeviceStatus(usr) ;
		switch(s){
			case 'F': // No Device is Busy/InUse
				return "<img src='images/status_green.png' border=0>";
				break ;
			case 'B': // Busy
				return "<img src='images/status_red.png' border=0>";
				break ;
			case 'R': // Ringing
				return "<img src='images/status_orange.png' border=0>";
				break ;
			case 'U': // UnAvailable
			default :
				return "<img src='images/status_gray.png' border=0>";
				break ;
		}
	},

	mailboxCount : function(mbox){ // ASTGUI.mailboxCount(mox) ; --> returns the number of New/Old Messages in mbox's mailbox
		if(!mbox.contains('@')){ mbox = mbox + '@default' ; }
		var t = makeSyncRequest ( { action :'MailboxCount', Mailbox: mbox } );
		var tr = { count_new:0 , count_old : 0 };
		try{
			var lines = t.split('\n');
			lines.each(function( this_line){
				if(!this_line.contains('Messages:') ) return;
				this_line = this_line.trim();
				if( this_line.contains('NewMessages:') ){
					tr.count_new = Number(this_line.afterChar(':').trim());
				}
				if( this_line.contains('OldMessages:') ){
					tr.count_old = Number(this_line.afterChar(':').trim());
				}
			});
		}finally{
			return tr;
		}
	},

	doTransfer : function(from, to) {
		ASTGUI.Log.Debug("About to transfer " + from + " to " + to);
		return makeSyncRequest ( { action :'redirect', channel :from, exten :to, context :'default', priority :'1' } );
	},

	doHangup : function(chan) {
		ASTGUI.Log.Debug("Executing hangup on channel : '" + chan + "'" );
		return makeSyncRequest ( { action :'hangup', channel: chan } );
	},

	cookies: {
		getCookie: function(x){ // ASTGUI.cookies.getCookie('username')
			var ck = top.document.cookie; // mansession_id="6f3fadcb"; username=admin
			if( ck.indexOf( x + '=' ) == -1 ){
				return '';
			}
			var cookies = ck.split(';');
			for(var y=0; y < cookies.length; y++){
				cookies[y] = cookies[y].strip();
				if( cookies[y].beginsWith(x +'=') ){
					return cookies[y].split( x + '=' )[1] ;
				}
			}
			return '';
		},

		setCookie: function(x , y){ // ASTGUI.cookies.setCookie( 'something' , 'valueofSomething' );
			var tmp = x + '=' + y + '; path = /' ;
			top.document.cookie = tmp;
		},

		setCookieOneMonth: function(x , y){ // ASTGUI.cookies.setCookie( 'something' , 'valueofSomething' );
			var d = new Date();
			d.setHours(d.getHours() + (24 * 30)); 
			var tmp =  x + '=' + y + '; path = /;' + 'expires=' + d.toGMTString();
			top.document.cookie = tmp;
		},

 		removeCookie: function(x){
 			top.document.cookie = x + '=somevalue; expires=Fri, 22 Oct 1999 00:00:00 UTC; path=/' ;

		},

		clearCookies: function(){  // ASTGUI.cookies.clearCookies()
			top.document.cookie = '';
		}
	},

	cloneObject: function(a){ // ASTGUI.cloneObject(obj)
		if(ASTGUI.isArray(a)){
			return [].concat(a);
		}
		if( typeof a != 'object' ){
			return a;
		}
		var b = new ASTGUI.customObject ;
		for( var i in a ){
			if( a.hasOwnProperty(i) ){
				b[i] = ASTGUI.toCustomObject( a[i] );
			}
		}
		return b;
	},

	CODECSLIST: {
		getSelectedCodecs : function(el){ // ASTGUI.CODECSLIST.getSelectedCodecs(el);
			if ( typeof el == 'string'){ el = _$(el) ; }
			var s = [];
			el.CODECS_SELECTEDORDER.each(function(codec){
				var t = codec.trim();
				if(t != ''){ s.push(codec); }
			});
			return s.join(',') ;
		},

		populateCodecsList : function(el){ // ASTGUI.CODECSLIST.populateCodecsList(el);
		// create codecs check boxes inside el and bind events to each checkbox such that the selected codecs 
			var r =  'codecs_chkbx_class' + Math.round( 10000 * Math.random() );
			if ( typeof el == 'string'){ el = _$(el) ; }
			el.checkboxClass = r;
			el.CODECS_SELECTEDORDER = [];
			ASTGUI.domActions.populateCheckBoxes(el , top.sessionData.listOfCodecs , r);
			$('.' + r).click(
				function() {
					if(this.checked){
						el.CODECS_SELECTEDORDER.push(this.value);
						return;
					}
					var t = el.CODECS_SELECTEDORDER.withOut(this.value);
					el.CODECS_SELECTEDORDER = t ;
					return ;
				}
			);
		},

		selectCodecs : function(el, codecs){ // ASTGUI.CODECSLIST.selectCodecs(el, codecs);
			// el is the element in which codec checkboxes are populated, codecs is the codecs string
			if ( typeof el == 'string'){ el = _$(el) ; }
			if( codecs == 'all' ){
				ASTGUI.domActions.CheckAll(el.checkboxClass);
				el.CODECS_SELECTEDORDER = ASTGUI.domActions.get_checked(el.checkboxClass);
			}else{
				if( codecs.trim() == '' ){
					el.CODECS_SELECTEDORDER = [] ;
				}else{
					el.CODECS_SELECTEDORDER = ( codecs.contains(',') ) ? codecs.split(',') : codecs;
				}
				ASTGUI.domActions.checkSelected( el.checkboxClass , el.CODECS_SELECTEDORDER ) ;
			}
		}
	},

	COMBOBOX: function (a,w){		// Usage - ASTGUI.COMBOBOX.call( element , OptionsArray, width(Optional)  );
		// this.comboDiv - the div element created
		// this.comboOptions - the array of options
		var e = this;
		var k = document.createElement('DIV');
		var continue_cleanup = true;

		var cleanupDiv = function(){
			var y = e;
			var sf = function(){
				if(!continue_cleanup) return;
				try{
					if(y.comboDiv){
						var q = y.comboDiv;
						q.parentNode.removeChild(q);
						delete y.comboDiv;
						ASTGUI.events.remove( y, 'blur' , cleanupDiv ) ;
						y.blur();
					}
				}catch(err){

				}
			};
			setTimeout( sf, 150 );
		};

		var creatediv = function(event){
			ASTGUI.events.add( e, 'blur' , cleanupDiv ) ;
			var u = e;
			var q = k.cloneNode(false);
			q.className = "comboMainDiv";
			if(w){ q.style.width = w; }
			u.comboDiv = q;
			var selectOption = function(event){
				continue_cleanup = false ;
				var f = ASTGUI.events.getTarget(event);
				u.value = f.getAttributeNode( 'actualvalue' ).value;
				continue_cleanup = true ;
				cleanupDiv();
			};

			ASTGUI.events.add( q , 'click' , selectOption );
			q.style.display = 'none' ;
			document.body.appendChild(q);
			ASTGUI.domActions.alignBbelowA(u,q);
			updateDivAndShow.call(e);
		};
	
		var updateDivAndShow = function(){
			var t = e.comboDiv ;
			var srchStng = e.value.toLowerCase() ;
			var z = e.comboOptions ;
			var y ;
			var matched = 0 ;
	
			ASTGUI.domActions.removeAllChilds(t);
			for (var r =0; r < z.length; r++){
				if( z[r].toLowerCase().contains(srchStng) || srchStng == '' ){
					y = k.cloneNode(false);
					y.innerHTML = z[r].bold_X( srchStng );
					y.setAttribute( 'actualvalue', z[r] );
					t.appendChild(y);
					matched++;
				}
			}
			setTimeout( function(){ t.style.display = (matched) ? '' : 'none'; } , 20 );
		};

		e.comboOptions = a.sort();
		ASTGUI.events.add( e, 'focus' , creatediv ) ;
		ASTGUI.events.add( e, 'keyup' , updateDivAndShow ) ;
	},

	customObject : function(){
		//	eliminates the need of 'hasOwnProperty' to read this objects propeties, look for this objects prototype below.
		if ( !(this instanceof ASTGUI.customObject) ) { return new ASTGUI.customObject(); }
	},

	toCustomObject : function(a){// if a is a native object returns an ASTGUI.customObject version of a
		if( ASTGUI.isArray(a) || a === null || typeof a =='number' || typeof a =='string' || typeof a =='boolean' || typeof a != 'object' ) return a;

		var b = new ASTGUI.customObject ;
		for( var i in a ){ if( a.hasOwnProperty(i) ){
			b[i] = ASTGUI.toCustomObject( a[i] );
		}}
		return b;
	},

	Log: {
 		doLog: function(msg, color){
 			if(!top.sessionData.DEBUG_MODE ){ return true; }
 			if( typeof msg == 'object' ){
 				msg = 'OBJECT : ' + ASTGUI.getObjectPropertiesAsString(msg) ;
 			}

 			var now = new Date();
 			var h = now.getHours().addZero() + ':' + now.getMinutes().addZero() + ':' + now.getSeconds().addZero() ;
 			if( top.sessionData.DEBUG_LOG.length > 250 ){
 				top.sessionData.DEBUG_LOG = top.sessionData.DEBUG_LOG.slice(0,50);
 			}
 			top.sessionData.DEBUG_LOG.unshift( h + ' <font color='+ color +'>' + msg + '</font>' );
 		},

 	Ajax: function(msg){ // ASTGUI.Log.Ajax(msg);
		if ( top.sessionData.DEBUG_WHICH.Ajax == true ) this.doLog( msg , '#96997C' );
 	},

 	Debug: function( msg ){ // ASTGUI.Log.Debug();
 		if ( top.sessionData.DEBUG_WHICH.Debug == true ) this.doLog( msg , '#4C9996' );
 	},

 	Error: function( msg ){ // ASTGUI.Log.Error();
		if( !top.sessionData || !top.sessionData.DEBUG_WHICH.Error ) return;
 		if( msg.length <=5 && ASTGUI.errorCodes[msg] ){
 			this.doLog( '<b>' + ASTGUI.errorCodes[msg] + '</b>' , '#992b23' );
 		}else{
 			this.doLog( '<b>' + msg + '</b>' , '#992b23' );
 		}
 	},

 	Console: function( msg ){ // ASTGUI.Log.Console();
 		if( top.sessionData.DEBUG_WHICH.Console == true && window.console && window.console.firebug ) console.log ( msg );
 	},

 	Info: function( msg ){ // ASTGUI.Log.Info(msg);
 		if( top.sessionData.DEBUG_WHICH.Info == true ) this.doLog( msg , '#9A9A9A' );
 	},

 	Warn: function( msg ){ // ASTGUI.Log.Warn( msg );
 		if( top.sessionData.DEBUG_WHICH.Warn == true ) this.doLog( msg , '#F47A00' );
 	}

	},

	dialog : {
		defaultMessage : 'Loading ...',
		load_iframe : function(msg){
			top.alertframename = "alertiframe" ;
			top.alertmsg = msg;
			try { top.document.getElementById(top.alertframename).contentWindow.update();} catch(e) { ASTGUI.Log.Error(e.message) }
			top.document.getElementById("alert_overlay").style.height = getDocHeight(top.document)+'px';
			top.document.getElementById("alert_overlay").style.display = "";
			top.document.getElementById(top.alertframename).style.display = "";
			top.document.getElementById(top.alertframename).focus();
		},

		waitWhile : function(msg){ 
			top.alertmsgtype = 2 ;
			this.load_iframe(msg);
		},

		alertmsg : function(msg){ // Ex: ASTGUI.dialog.alertmsg('Some Alert Message');
			top.alertmsgtype = 1 ;
			this.load_iframe(msg);
		},

		hide : function(){
			try{
				top.document.getElementById("alert_overlay").style.display = "none";
				top.document.getElementById("alertiframe").style.display = "none";
			} catch (err){ }
		},

		show : function(){
			try{
				top.document.getElementById("alert_overlay").style.display = '';
				top.document.getElementById("alertiframe").style.display = "";
			} catch (err){ }
		}
	},

	domActions: {
		alignBbelowA: function(a,b, offsetLeft, offsetTop ){
			if ( typeof a == 'string'){ a = _$(a) ; }
			if ( typeof b == 'string'){ b = _$(a) ; }
			b.style.position = 'absolute';
			var tmp_left = a.offsetLeft;
			var tmp_top = a.offsetTop + a.offsetHeight;
			var tmp_parent = a;
	
			while(tmp_parent.offsetParent != document.body){
				tmp_parent = tmp_parent.offsetParent;
				tmp_left += tmp_parent.offsetLeft;
				tmp_top += tmp_parent.offsetTop;
			}
			b.style.left = tmp_left + ( offsetLeft || 0 );
			b.style.top = tmp_top + (offsetTop || 1);
		},

		alignBontopofA: function(a,b){ // ASTGUI.domActions.alignBontopofA();
			try{
				if ( typeof a == 'string'){ a = _$(a) ; }
				if ( typeof b == 'string'){ b = _$(b) ; }
				ASTGUI.domActions.alignBbelowA(a,b);
				b.style.top = b.style.top - a.offsetHeight ;
			}catch(err){

			}
		},

		bindMenu: function(m,n){
			// assigns menu list element 'm' to button/span/element 'n' 
			// m will be aligned below n , 
			// and when n is clicked m will be displayed, and if clicked anywhere else on the document m will be 'hidden'
			if ( typeof m == 'string'){ m = _$(m) ; }
			if ( typeof n == 'string'){ n = _$(n) ; }
			ASTGUI.events.add( n , 'click' , function(b){
					(b||window.event).cancelBubble = true;
					ASTGUI.domActions.alignBbelowA(n, m);
					m.style.display = '';
					n.style.background ='#a8b6e5';
				}) ;
			ASTGUI.events.add( document , 'click' , function(){ n.style.background =''; m.style.display ='none' ;} ) ;
		},

		CheckAll: function(x){ // check all checkboxes of class x - ASTGUI.domActions.CheckAll();
			var y = $("." + x) ;
			for(var g=0, h = y.length; g < h; g++){
				if(!y[g].disabled){
					y[g].checked = true;
				}
			}
		},

		disableAllofClass: function(x){ // disable all fields of class x
			var y = $("." + x) ;
			for(var g=0, h = y.length; g < h; g++){
				y[g].disabled = true;
			}
		},
		
		enableAllofClass: function(x){ // enables all fields of class x
			var y = $("." + x) ;
			for(var g=0, h = y.length; g < h; g++){
				y[g].disabled = false;
			}
		},

		checkIf_isAstTrue: function(el, str){ // ASTGUI.domActions.checkIf_isAstTrue(el,str);
			if ( typeof str != 'string' ){ return; }
			if ( typeof el == 'string' ){ el = _$(el); }
			el.checked = ( str.isAstTrue() ) ? true:false ;
		},

		checkSelected: function(x,y){ // ASTGUI.domActions.checkSelected( 'class', [val1,val2,...]);
			// x is class of checkboxes, y is an array of values, this functions checks a checkbox if it its value is present in array 'y'
			//try{
				var checkcbv = function(a,b){
					for(var i=0;i<a.length;i++){
						if(!b.contains(a[i])){
							return false;
						}
					}
					return true;
				};
				var checkchb = function(c,d){
					for(var n=0;n<c.length;n++){
						if(c[n] == d) return true;
					}
					return false;
				};
				var y_copy = ASTGUI.cloneObject(y);
				var chbs = $( "." + x ) ; //jquery selector
				for( var g=0, h = chbs.length; g < h  ; g++ ) {
					var cbv = chbs[g].value.split("&");
					if(cbv.length == 1){
						chbs[g].checked = checkchb(y_copy,chbs[g].value);
					}else{
						chbs[g].checked = checkcbv(cbv,y_copy);
					}
				}
			//}catch(err){ }
		},

		disableSelected: function(x,y){	// disable some fields (whose "values" (not names or ids) are in array y), of class x 
			// ASTGUI.domActions.disableSelected( 'class', [1,2] );
			var chbs = $( "." + x ) ; //jquery selector
			for( var g=0, h = chbs.length; g < h  ; g++ ) {
				chbs[g].disabled = ( y.contains(chbs[g].value) ) ? true : false ;
			}
		},

		clear_table: function(h){ // ASTGUI.domActions.clear_table($el)
			if ( typeof h == 'string'){ h = _$(h) ; }
			for( var i=0; i <  h.rows.length; ){ h.deleteRow(i); }
		},

		get_checked: function (x){ // returns an array of selected checkbox values  from a set of checkboxes of class x
			var chk = [] ;
			var y = $( "." + x ) ; //jquery selector
			for( var g=0, h = y.length; g < h  ; g++){
				if(y[g].checked){
					chk.push( y[g].value );
				}
			}
			return chk;
		},

		removeAllChilds: function(x){ // ASTGUI.domActions.removeAllChilds(el);
			if ( typeof x == 'string'){ x = _$(x) ; }
			while(x.firstChild){
				x.removeChild(x.firstChild);
			}
		},

		setTextbox_DefaultValue: function(el, defval){ // usage :: ASTGUI.domActions.setTextbox_DefaultValue(el, "Default Value") ;
			if ( typeof el == 'string'){ el = _$(el) ; }
			el.defaultValue = defval;
			el.value = defval;
			$(el).focus(
				function(){
					if( this.value == this.defaultValue ){
						this.value = '' ;
					};
				}
			);
			$(el).blur(
				function () {
					if( this.value == '' ){
						this.value = this.defaultValue ;
					}
				}
			);
		},
		
		 select_a2b:function(a,b){
			if(a.selectedIndex < 0){return false;}
			ASTGUI.selectbox.append(b,a.options[a.selectedIndex].text, a.options[a.selectedIndex].value);
			a.remove(a.selectedIndex);
		},

		tr_addCell: function(tr, nc){ // usage :: ASTGUI.domActions.tr_addCell( el, { html:'newCell Text' , align:'center', width:'20px' }  )
			var ih = nc.html; delete nc.html;
			var newcell = tr.insertCell( tr.cells.length );
			if( nc.id ){ newcell.id = nc.id ; delete nc.id; }
			if( nc.langtag ){ newcell.lang = nc.lang; delete nc.lang; }
			if( nc.width ){ newcell.width = nc.width; delete nc.width; }
			newcell.innerHTML = ih;
			if( nc.onclickFunction && typeof nc.onclickFunction == "function" ){
				ASTGUI.events.add( newcell , 'click' , nc.onclickFunction ) ;
				$(newcell).css('cursor', 'pointer');
				delete nc.onclickFunction;
			}
			for( var k in nc){
				if( nc.hasOwnProperty(k) ){
					if(k.toLowerCase() == 'colspan'){
						newcell.colSpan = nc[k];
					}else{
						newcell[k] = nc[k];
					}
				}
			}

		},

		unCheckAll: function(x){ // uncheck all checkboxes of class x
			var y = $("." + x) ; //jquery selector
			for(var g=0, h = y.length; g < h; g++){
				y[g].checked = false;
			}
		},

		populateCheckBoxes: function( div, values, ofclass, withBR){ // ASTGUI.domActions.populateCheckBoxes(div, values, ofclass);
			// represent 'array values' OR 'Object values' as a list of checkboxes of class 'ofclass' as childnodes of element 'div'
			// Ex: values = { '1':'One', '1':'Two' } or values = [1,2]
			var c = {};
			if(ASTGUI.isArray(values)){
				values.each( function(tv){ c[tv] = tv; } );
			}else{
				c = values;
			}
			if ( typeof div == 'string'){ div = _$(div) ; }
			for(var d in c){
				if(c.hasOwnProperty(d)){
					var nbr = document.createElement( 'SPAN' ) ;
					var lbl = document.createElement( 'label' ) ;
						var ncbx = document.createElement('input') ;
							ncbx.type = 'checkbox' ;
							ncbx.value = d ;
							ncbx.id = Math.round(10000*Math.random()) + '_' + d ;
							ncbx.style.border = "0px";
							ncbx.className = ofclass ;
						var span = document.createElement('SPAN') ;
						c[d] = c[d].substr(0, 1).toUpperCase() + c[d].substr(1); //uppercase first letter 
						span.innerHTML = (withBR) ? c[d] + '&nbsp;<br />' : c[d] + '&nbsp;' ;
					lbl.innerHTML = '';
					lbl.appendChild(ncbx) ;
					lbl.appendChild(span) ;
					nbr.appendChild(lbl);
					div.appendChild(nbr) ;
				}
			}
		},

		showHideByCheckBox: function(chk , el){ // ASTGUI.domActions.showHideByCheckBox (chk, el) ;
			if ( typeof chk == 'string'){ chk = _$(chk) ; }
			if ( typeof el == 'string'){ el = _$(el) ; }
			chk.updateStatus = function(){ el.style.display = (chk.checked)?'':'none'; } ;
			ASTGUI.events.add( chk, 'click' , chk.updateStatus );
		},

		HideshowByCheckBox: function(chk , el){ // ASTGUI.domActions.showHideByCheckBox (chk, el) ;
			if ( typeof chk == 'string'){ chk = _$(chk) ; }
			if ( typeof el == 'string'){ el = _$(el) ; }
			chk.updateStatus = function(){ el.style.display = (chk.checked)?'none':''; } ;
			ASTGUI.events.add( chk, 'click' , chk.updateStatus );
		},

		showHideClassByCheckBox: function(chk , cLass, rClass , reverse_behaviour){ // ASTGUI.domActions.showHideClassByCheckBox(chk, cLass) ;
			if ( typeof chk == 'string'){ chk = _$(chk) ; }
			chk.updateStatus = function(){
				if(reverse_behaviour ){
					if(chk.checked){
						$('.'+cLass).hide();
					}else{
						$('.'+cLass).show();
					}
				}else{
					if(chk.checked){
						$('.'+cLass).show();
					}else{
						$('.'+cLass).hide();
					}
				}
				if(rClass != null){ ReSizeIframeTo($(rClass).outerHeight()) };
			};
			ASTGUI.events.add( chk, 'click' , chk.updateStatus );
		},

		enableDisableByCheckBox: function(chk , el, reverse_behaviour) { // ASTGUI.domActions.enableDisableByCheckBox (chk, el) ;
			// this function can also use for radio boxes
			if ( typeof chk == 'string'){ chk = _$(chk) ; }
			if ( typeof el == 'string'){ el = _$(el) ; }
			if( ASTGUI.isArray(el) ){
				chk.updateStatus = function(){
					el.each( function(el_this){
						if ( typeof el_this == 'string'){ el_this = _$(el_this) ; }
						if(!reverse_behaviour){
							el_this.disabled = !(chk.checked);
						}else{
							el_this.disabled = chk.checked;
						}
					});
					
				};
			}else{
				if(!reverse_behaviour){
					chk.updateStatus = function(){ el.disabled = !(chk.checked) } ;
				}else{
					chk.updateStatus = function(){ el.disabled = chk.checked; } ;
				}
			}

			ASTGUI.events.add( chk, 'click' , chk.updateStatus );
		}
	},

	events: {
		getTarget: function(x){
			x = x || window.event;
			return x.target || x.srcElement;
		},
		add: function(a,b,c){ // a is element , b is event (string) , c is the function 
			if ( typeof a == 'string'){ a = _$(a) ; }
			if($.browser.msie){
				a.attachEvent('on'+b, c);
				return;
			}
			if(a.addEventListener){
				a.addEventListener(b, c, false);
				return;
			}
			a['on'+b] = c ;
		},
		remove: function(a,b,c){
			if ( typeof a == 'string'){ a = _$(a) ; }
			if($.browser.msie){
				a.detachEvent('on'+b, c);
				return;
			}
			if(a.removeEventListener){
				a.removeEventListener(b, c, false);
				return;
			}
			a['on'+b] = null ;
		}
	},


	feedback : function( fb ){
		// usage  ::  ASTGUI.feedback( { msg:'your message here', showfor:2, color:'#000000', bgcolor:'#FFFFFF' } );
//		top.miscFunctions.setFeedback(fb);
		// donot call this function directly 
		// instead do -- ASTGUI.feedback( { msg:'your message here', showfor:2 } );
//		fb.showfor = 5; // over write all showfor values (kenny said messages are disappearing before anyone could read them)
		
		var k = $("#feedback")[0]? $("#feedback"):parent.$("#feedback");
		if( top.sessionData.fbtimer ){ clearTimeout( top.sessionData.fbtimer ); }
		if (!fb){ k.hide(); return true; }
		if( !fb.showfor){ fb.showfor = 3; }
		if( !fb.color){ fb.color = '#FFF'; }
		
		k.css({ fontWeight: "", color: fb.color });
		k[0].innerHTML = fb.msg ;
//		k.show();
		setTimeout( function(){ top.window.scroll(0,0); } , 50 );
		var clearFb = function(){ 
			top.sessionData.fbtimer = 0;
			k[0].innerHTML='';
//			k.hide();
		};
		top.sessionData.fbtimer = setTimeout( clearFb , fb.showfor*1000 );
	},
	
	getFieldValue : function(el){ // ASTGUI.getFieldValue(el)
		if ( typeof el == 'string'){ el = _$(el) ; }
		switch(el.type){
			case 'checkbox':
				return (el.checked) ? 'yes':'no' ;
				break;
			case 'radio':
				return (el.checked) ? el.value : '' ;
				break;
			case 'select-one':
				return el.value.trim();
				break;
			case 'password':
				return el.value;
				break;
			case 'text':
			case 'textarea':
			default:
				return el.value.trim() ;
				break;
		}
		return '';
	},

	getObjectPropertiesAsString : function(a){ // takes an object and returns all its properties, values as a string
		var ar = [];
		for(var d in a){
			if(!a.hasOwnProperty(d)){ continue; }

			if( typeof a[d] == 'object' ){
				if( ASTGUI.isArray(a[d]) ){
					ar.push(  d + ' : [' + a[d].join(',') + ']' );
				}else{
					ar.push(  d + ' : ' + ASTGUI.getObjectPropertiesAsString(a[d]) );
				}
			}else{
				ar.push(d + ' : '+ a[d]);
			}
		}
		return '{' + ar.join(' ,') + '}' ;
	},

	getTrunkStatus : function (registry , trunkname, ttype){ // ASTGUI.getTrunkStatus (registry, trunkname);
		var this_IP = '';
		if(!ttype || ( ttype != 'sip' && ttype != 'iax' && ttype != 'providers' ) ){ return '--'; }
		if( ttype == 'providers' ){
			var uname = top.sessionData.pbxinfo.trunks[ttype][trunkname]['username'];
			var host = top.sessionData.pbxinfo.trunks[ttype][trunkname]['host'];
			ttype = parent.astgui_managetrunks.misc.getProviderTrunkType(trunkname); // find 'sip' or 'iax'
			if ( ttype != 'sip' && ttype != 'iax'){
				return '--';
			}
		}else{
			var uname = top.sessionData.pbxinfo.trunks[ttype][trunkname]['username'];
			var host = top.sessionData.pbxinfo.trunks[ttype][trunkname]['host'];
		}
		if( !uname) {return '';}

		(function(){
			if(ttype=='iax'){var a ='iax2';}
			if(ttype=='sip'){var a ='sip';}
			var t = ASTGUI.cliCommand(a + ' show peer ' + trunkname) ;
			t = ASTGUI.parseCLIResponse( t );
			var IP = '';
			var s = t.split('\n');
			for(var i=0; i < s.length; i++ ){
				var line = s[i];
				if(line.contains('Addr->IP') ){ // if line is  'Addr->IP     : 68.62.219.197 Port 5060'
					var tmp = line.afterChar(':'); // tmp = '68.62.219.197 Port 5060' ;
					var tmp2 = tmp.split(' Port ');
					IP = tmp2.join(':');
					IP = IP.trim();
					this_IP = IP;
					return;
				}
			}
		})();

		if(ttype=='iax'){
			var lines = registry.iax2.split('\n');
		}else if(ttype=='sip'){
			var lines = registry.sip.split('\n');
		}

		//var uname_lc = uname.toLowerCase();
		// TODO: come up with a better alternative than this
		// cli output of 'sip show registry' shows only a part of long usernames
		var uname_lc = uname.toLowerCase().substr(0,12);

		for(var i = 0; i < lines.length; i++) {
			var line = lines[i].trim().toLowerCase();
			if (!line || line.beginsWith('host') ){ continue; }
			if( ( line.beginsWith(host+':') || ( this_IP && line.beginsWith(this_IP + ' ') ) )  && line.contains( ' ' + uname_lc + ' ' ) ){
				if( line.contains(' registered') ){
					return '<font color=green>Registered</font>' ;
				}else if( line.contains('auth. sent') ){
					return '<font color=red>Waiting for Authentication</font>';
				}else if( line.contains('request sent') ){
					return '<font color=red>Request Sent</font>';
				}else if( line.contains('rejected') ){
					return '<font color=red>Rejected</font>';
				}else if( line.contains('unregistered') ){
					return '<font color=red>Unregistered</font>';
				}else{
					return '<font color=red>Unregistered</font>';
				}
			}
		}
		return '<font color=red>Unregistered</font>';
	},

	parseGETparam : function(url_string, getparam ){ // ASTGUI.parseGETparam( url , 'EXTENSION_EDIT');
		// parse a URL string and return the value of a GET parameter
		// url can be in '....html?EXTENSION_EDIT=XXXX&YYYYYYY...' or '....html?EXTENSION_EDIT=XXXX'
		var t = getparam + '=' ;
		if( url_string.contains(t) ){
			var g = url_string.afterStr(t);
			return g.contains('&') ? g.beforeChar('&') : g ;
		}
		return '';
	},

	hideDrag : function(event){
		// Use this as a Cancel Button event, DONOT use this for hiding the div after save()/update(),  use the '$().hideWithBg()' instead
		var et = ASTGUI.events.getTarget(event) ;
		while( et.nodeName.toUpperCase() != 'DIV' ){ et = et.parentNode ; }
		et.style.display = 'none';
//		ReSizeIframe();
		ASTGUI.feedback( { msg:ChangesCancelled } );
		try{
			et.ownerDocument.getElementById('bg_transparent').style.display ='none';
		}catch(err){}
	},

	isNull : function(a){
		return a===null
	},

	isArray: function(a){ //	ASTGUI.isArray(a) ;
		return a instanceof Array || ( a!= null && typeof a=="object" && typeof a.push == "function" && typeof a.concat == "function" )
	},

	loadHTML: function(u){ // loads URL 'u' in synchronus mode. note that url 'u' is restricted by same origin policy
		var r =  Math.round(10000*Math.random());
		var s = $.ajax({ url: u + '?r=' + r , async: false });
		return s.responseText;
	},
	
	loadfilecontent: function(filename,cb){
		this.systemCmdWithOutput( this.apps.cat + filename , function(content){
			cb(content);
		});
	},

	listSystemFiles : function( dir , cb ){
		this.systemCmdWithOutput( this.scripts.ListFiles + ' ' +  dir , function(op){
			var tmp_files = op.split('\n');
			var files = [];
			for( var i =0 ; i < tmp_files.length ; i++){
				if( typeof tmp_files[i] == "undefined" ){ continue; }
				tmp_files[i] = tmp_files[i].trim();
				if( tmp_files[i] == "" ){ continue; }
				files.push(tmp_files[i]);
			}
			cb(files);
		});
	},
	
	ListFilesWithExtension : function( dir , cb ){
		this.systemCmdWithOutput( this.scripts.ListFilesWithExtension + ' ' +  dir , function(op){
			var tmp_files = op.split('\n');
			var files = [];
			for( var i =0 ; i < tmp_files.length ; i++){
				if( typeof tmp_files[i] == "undefined" ){ continue; }
				tmp_files[i] = tmp_files[i].trim();
				if( tmp_files[i] == "" ){ continue; }
				files.push(tmp_files[i]);
			}
			cb(files);
		});
	},

	listSystemFilesAndSubdirs : function( dir , cb ){
		this.systemCmdWithOutput( this.scripts.ListFilesAndSubs + ' ' +  dir , function(op){
			var tmp_files = op.split('\n');
			var files = [];
			for( var i =0 ; i < tmp_files.length ; i++){
				if( typeof tmp_files[i] == "undefined" ){ continue; }
				tmp_files[i] = tmp_files[i].trim();
				if( tmp_files[i] == "" ){ continue; }
				files.push(tmp_files[i].replace(dir, ''));
			}
	
			cb(files);
		});
	},

	miscFunctions: {
		getChunksFromManagerOutput : function( op , usf){ // ASTGUI.miscFunctions.getChunksFromManagerOutput( output_str ) ;
			var tr_Array = [];
			var tmp_chunk = (usf) ? {} : [] ;
			var count = 0;
			var tmp_lines = op.split('\r\n').join('\n').split('\r').join('\n').split('\n');
			if( tmp_lines[0].contains('Response: ') ) tmp_lines.removeFirst();
			if( tmp_lines[0].contains('Message: ') ) tmp_lines.removeFirst();

			for( var r = 0; r < tmp_lines.length ; r++ ){
				var this_line = tmp_lines[r];
				if( this_line.trim() == '' ){
					if( !count ){ continue; }
					tr_Array.push(tmp_chunk);
					tmp_chunk = (usf) ? {} : [] ;
					count = 0;
					continue;
				}

				if( !this_line.contains(': ') ){ continue;  }

				if( usf ){
					tmp_chunk[ this_line.beforeStr(': ').trim() ] = this_line.afterStr(': ').trim() ;
				}else{
					tmp_chunk.push(this_line) ;
				}
				count++ ;
			}

			return tr_Array ;
		},


		createConfig : function( fileName, callback){ // ASTGUI.miscFunctions.createConfig( 'filaName', function(){ } ) ;
			var s = $.ajax({ url: ASTGUI.paths.rawman+'?action=createconfig&filename='+ fileName , async: false }).responseText;
			callback();
		},

		ArrayContains : function(arr, str){ // ASTGUI.miscFunctions.ArrayContains(arr, str )
			// There is already an Array.prototype function for this
			// but IE is going crazy when using the prototype method on a parent window array
			for(var i=0, j = arr.length ; i < j; i++ ){
				if( arr[i] === str ) return true;
			}
			return false;
		},
			
		moveUpDown_In_context: function(context, line , updown , cbf ){ 	// ASTGUI.miscFunctions.moveUpDown_In_context( ct , line , bool , cbf ) // bool = 0 for Down , 1 for Up 
			updown = Number(updown);
			var t = context2json({ filename:'extensions_custom.conf' , context : context , usf: 0 });
	
			if( !t.contains(line) ){ // Could not find the rule in this context.
				cbf(t);
			}
	
			for( var ti = 0 ; ti < t.length ; ti++ ){
				if( t[ti] == line ){
					var tmp_a = (updown) ? t[ ti - 1 ] : t[ ti + 1 ] ;
					t[ti] = tmp_a ;
					if( updown == 1 ){ // move up
						t[ti-1] = line ;
					}else{ // move down
						t[ti+1] = line ;
					}
					break;
				}
			}

			ASTGUI.miscFunctions.empty_context({ filename:'extensions_custom.conf', context : context, cb : function(){
				var x = new listOfActions('extensions_custom.conf');
				t.each(function( this_line ){
					x.new_action('append', context , this_line.beforeChar('=') ,  this_line.afterChar('=') );
				});
				x.callActions( function(){
					cbf(t);
				});
			}});
		},

		empty_context: function( ct ){ // ASTGUI.miscFunctions.empty_context({ filename:'somefile.conf', context : 'context_x', cb : fn })
			var u = new listOfSynActions(ct.filename);
			u.new_action('emptycat', ct.context , '', '' ) ;
			u.callActions();
			ct.cb();
			return;
		},

		delete_LinesLike: function( ct ){
			// ASTGUI.miscFunctions.delete_LinesLike({ context_name : 'voicemailgroups' , beginsWithArr: ['exten=6050,'] , filename: 'extensions_custom.conf', hasThisString:'somestring', cb:function(){} });
			var sel_cxt = context2json({ filename: ct.filename, context : ct.context_name , usf:0 });
			if ( typeof ct.beginsWithArr == 'string' ){
				ct.beginsWithArr = [ct.beginsWithArr];
			}

			var lines_to_delete = [];
				sel_cxt.each( function( line ){
					ct.beginsWithArr.each( function( this_beginsWithStr ){
						if( ct.hasThisString ){
							if( line.beginsWith( this_beginsWithStr ) && line.contains( ct.hasThisString) ){
								lines_to_delete.push( line );
							}
						}else{
							if( line.beginsWith( this_beginsWithStr ) ){
								lines_to_delete.push( line );
							}
						}
					});
				});

			var x = new listOfActions(ct.filename);
			lines_to_delete.each( function(line){
				var var_name = line.beforeChar('=');
				var var_value = line.afterChar('=');
				x.new_action('delete', ct.context_name , var_name, '', var_value);
			});

			x.callActions(ct.cb);
		},

		chanStringToArray: function(chs){ // ASTGUI.miscFunctions.chanStringToArray();
			// expects chs as '5' or '5-8' or '5,6,7,8' and returns [5] or [5,6,7,8]
			if ( !chs ) return [];
			if ( typeof chs != 'string') chs = String(chs) ;
			chs = chs.trim();
			var tr = [];

			if( chs.contains(',') ){
				var s = chs.split(',');
				tr = tr.concat(s);
				tr.forEach( function(u){ return String(u); } );
				return tr;
			}

			if( chs.contains('-') ){
				var a = Number( chs.beforeChar('-') );
				var b = Number( chs.afterChar('-') );
				for( var i=a; i <= b ; i++ ){
					tr.push( String(i) ) ;
				}
				return tr;
			}

			return [chs];
		},

		alertIfRangeisNotdefined: function(a , b, for_what){ // ASTGUI.miscFunctions.alertIfRangeisNotdefined();
			if(!a || !b){return true;}
			if( !top.sessionData.GUI_PREFERENCES.getProperty(a) || !top.sessionData.GUI_PREFERENCES.getProperty(b) ){
				ASTGUI.dialog.alertmsg("You do not have an extension range defined for '"+ for_what +"'. Please define your <i>Extension Preferences</I> from the 'Options' panel");
				return false;
			}
			return true;
		},

		isExtensionInRange: function(ext,a,b){ // ASTGUI.miscFunctions.isExtensionInRange('6000','ue_start','ue_end') ;
			var v = top.sessionData.GUI_PREFERENCES.getProperty(a) ;
			var w = top.sessionData.GUI_PREFERENCES.getProperty(b) ;
			if( !v || !w ){
				return true;
			}
			return ext.isValueInBetween(v, w);
		},

		AMPM_to_asteriskTime: function(ampmTime){ // takes ampmTime as '12:15 AM' or '11:45 PM' and returns '00:15' or '23:45'
			//ASTGUI.miscFunctions.AMPM_to_asteriskTime('12:15 AM');
			if( ampmTime.endsWith(' PM') ){
				var a = ampmTime.withOut(' PM');
				var tmp = a.split(':') ;
				var hour = Number(tmp[0]);
				return (hour == 12) ? hour + ':' + tmp[1] : ( hour + 12 ) + ':' + tmp[1] ;
			}

			if( ampmTime.endsWith(' AM') ){
				var a = ampmTime.withOut(' AM');
				var tmp = a.split(':') ;
				var hour = Number(tmp[0]);
				return ( hour == 12 ) ? '00:' + tmp[1]  : tmp[0] + ':' + tmp[1] ;
			}
			return '';
		},
		
		asteriskTime_to_AMPM: function(atime){ // takes atime as '00:15' or '23:45' and returns '12:15 AM' or '11:45PM'
			//ASTGUI.miscFunctions.asteriskTime_to_AMPM('23:15');
			if( atime != '' ){
				var hour = atime.split(':')[0];
				var mins = atime.split(':')[1];
				if( hour == '00' ){
					return '12:' + mins + ' AM';
				}
				if( Number(hour) < '12' ){
					return hour + ':' + mins + ' AM';
				}
				if( hour == '12' ){
					return hour + ':' + mins + ' PM';
				}
				if( Number(hour) > 12 ){
					return (Number(hour)-12).addZero() + ':' + mins + ' PM';
				}
				return '--';
			}else { return '--' };
		},

		GotoIftime_in_humanReadable: function( gotoiftime_str ){ 
			//ASTGUI.miscFunctions.GotoIftime_in_humanReadable( '08:00-17:00|mon-fri|*|*' ) ; // returns a human readable form as ' 8 AM to 5 PM on Monday through Friday'
			var WEEKDAYS = {mon: 'Monday', tue: 'Tuesdays', wed: 'Wednesday', thu: 'Thursday', fri: 'Friday', sat:'Saturday', sun:'Sunday'};

			var PIECES = gotoiftime_str.split('|') ;
			var toreturn = [];
			if( PIECES[0] != '*' ){
				toreturn.push( ASTGUI.miscFunctions.asteriskTime_to_AMPM(PIECES[0].split('-')[0]) + ' to ' +  ASTGUI.miscFunctions.asteriskTime_to_AMPM(PIECES[0].split('-')[1]) );
			}

			if( PIECES[2] == '*' && PIECES[3] == '*' ){ // by week days
				if( PIECES[1].contains('-') ){ // range of week days
					toreturn.push( 'on ' + WEEKDAYS[PIECES[1].split('-')[0]] + ' through ' + WEEKDAYS[PIECES[1].split('-')[1]]  );
				}else{
					toreturn.push( 'on ' + WEEKDAYS[PIECES[1]] + 's' );
				}

				return toreturn.join(' ');
			}else{ // by days of month
				if( PIECES[2].contains('-') ){ // range of dates
					if( PIECES[3] != '*' ){
						toreturn.push( 'on ' + PIECES[3] + ' ' + PIECES[2].split('-')[0] + ' through ' + PIECES[3] + ' ' + PIECES[2].split('-')[1] );
					}else{
						toreturn.push( 'on ' + PIECES[2].split('-')[0] + ' through ' + PIECES[2].split('-')[1] + ' of any Month'  );
					}
				}else{
					toreturn.push( 'on ' + PIECES[3] + ' ' + PIECES[2].split('-')[0] );
				}
				return toreturn.join(' ');
			}
		}
	},

	parseCLIResponse : function (op){ // op is CLI command output via http 
		op = op.replace(/Response: Follows/, "");
		op = op.replace(/Privilege: Command/, "");
		op = op.replace(/--END COMMAND--/, "");
		return op;
	},

	parseContextLine: {
		read: function(q){ // ASTGUI.parseContextLine.read();
			// expects q as 'blah=foo' and returns ['blah','foo']
			var v = q.indexOf("=");
			if( v == -1){ return []; }
			return  [q.substring(0,v), q.substr(v+1)];
		},

		getExten: function(q){ // ASTGUI.parseContextLine.getExten();
			// use this when you want to get the pattern from a calling rule
			// expects q as 'exten=_X.,1,foo' or '_X.,1,foo'
			//	and returns _X.
			if( !q || !q.contains(',') ) { return ''; }
			if( q.match('exten=') ){
				return q.split('exten=')[1].split(',')[0];
			}else{
				return q.split(',')[0];
			}
		},

		getPriority: function(q){ // ASTGUI.parseContextLine.getPriority();
			// expects  q  as 'exten=s,2,foo' OR 's,2,foo'   and   returns 2
			if( q.match('exten=') ){
				return q.split('exten=')[1].split(',')[1].trim();
			}else{
				return q.split(',')[1].trim();
			}
		},

		getAppWithArgs: function(q){ // ASTGUI.parseContextLine.getAppWithArgs();
			// expects  q  as 'exten=s,2,foo(ssssssss,ssdsd,assd)' OR 's,2,foo(ssssssss,ssdsd,assd)' OR even 'foo(ssssssss,ssdsd,assd)'
			//	and   returns 'foo(ssssssss,ssdsd,assd)' ;  app with arguments(if any)

			if( !q.contains('(') ){ // if q == something like 's,n,Hangup' return 'Hangup'
				var l = q.lastIndexOf(',');
				return q.substring(l+1);
			}else{
				var tmp = q.beforeChar('(') ;
				if( !tmp.contains(',') ){
					return q;
				}else{
					var l = tmp.lastIndexOf(',');
					return q.substring(l+1);
				}
			}
			ASTGUI.Log.Error( "ASTGUI.parseContextLine.getAppWithArgs() could not parse \"" + q + "\" " );
			return '';
		},

		getApp: function(q){ // ASTGUI.parseContextLine.getApp();
			// expects  q  as 'exten=s,2,foo(ssssssss,ssdsd,assd)' OR 's,2,foo(ssssssss,ssdsd,assd)'   
			//	and   returns 'foo' ;// appname -- without arguments
			var y = ASTGUI.parseContextLine.getAppWithArgs(q);
			return ( y.contains('(') ) ? y.split('(')[0].trim() : y.trim() ;
		},

		getArgs: function(q){ // ASTGUI.parseContextLine.getArgs();
			// expects  q  as 'exten=s,2,foo(ssssssss,ssdsd,assd)' OR 's,2,foo(ssssssss,ssdsd,assd)' OR 's,2,foo(ssssssss|ssdsd|assd)'
			// OR 's,1,Answer' OR 's,n,Hangup'
			// and   returns [ssssssss,ssdsd,assd] or [] // arguments as an array 

			q = q.trim();
			if ( !q.endsWith(')') || !q.contains('(') ){
				ASTGUI.Log.Error( "ASTGUI.parseContextLine.getArgs() - No Argument found for \"" + q + "\" " );
				return [];
			}
			var y = ASTGUI.parseContextLine.getAppWithArgs(q);
			y = y.substr(0, (y.length-1));
			var x = y.afterChar('(');
			return this.getArgsArrayFromArgsString(x);
		},

		getArgsArrayFromArgsString: function(x){ // expects x as 'context,exten,pri' or 'context|exten|pri'
			if(x.contains('|') ){
				return x.split('|');
			}
			if(x.contains(',') ){
				return x.split(',');
			}
			return [x] ;
		},

		getArgsArrayFrom_AppWithArgs_String: function(x){ // expects x as 'goto(context,exten,pri)' or 'goto(context|exten|pri)'
			// usage : ASTGUI.parseContextLine.getArgsArrayFrom_AppWithArgs_String(x)
			if( !x.contains('(') ) {
				return this.getArgsArrayFromArgsString(y);
			}
			var y = x.substr(0, (x.length-1));
			    y = y.afterChar('(');
			return this.getArgsArrayFromArgsString(y);
		},

		toKnownContext: function(args){  // usage ASTGUI.parseContextLine.toKnownContext(y)
			// converts args to a readable format - ex: default|6000|1 to 'user 6000'
			if(typeof args == 'string'){
				args = this.getArgsArrayFromArgsString(args);
			}
			if( args[0] == 'default' ){
				var u = args[1] ;
				if( u == 'o'){
					return 'Goto Operator';
				}
				if( top.sessionData.pbxinfo.users.hasOwnProperty(u) ){
					return 'Goto User ' + u ;
				}
			};
			if( args[0] == ASTGUI.contexts.QUEUES ){
				return 'Goto Queue ' + args[1] ;
			};
			if( args[0] == ASTGUI.contexts.CONFERENCES ){
				return 'Goto Conference ' + args[1] ;
			};
			if( args[0].contains(ASTGUI.contexts.RingGroupPrefix) ) {
				try {
					if( top.sessionData.pbxinfo['ringgroups'].hasOwnProperty(args[0]) ){
						var rgname = top.sessionData.pbxinfo['ringgroups'][args[0]].NAME ;
					}else{
						var rgname = ' ' + args[0] +  ' <font color=red><b>?</b></font>' ;
					}
				} catch(err) {
					rgname = 'Error'
				}
				return 'Goto RingGroup ' + rgname ;
			};
			if( args[0].contains(ASTGUI.contexts.TimeBasedRulePrefix) ){
				try {
					var tbr_label = top.sessionData.pbxinfo.timebasedRules[args[0]].label || args[0] ;
				} catch(err) {
					tbr_label = 'Error'
				}
				return 'Goto TimeBased Rule -- ' + tbr_label  ;
			};
			if( args[0].contains(ASTGUI.contexts.VoiceMenuPrefix) ){
				try {
					var vm_name = top.sessionData.pbxinfo.voicemenus[args[0]].comment || args[0] ;
				} catch(err) {
					vm_name = 'Error'
				}
				return 'Goto VoiceMenu -- ' + vm_name ;
			};
			if( args[0].contains(ASTGUI.contexts.DISAPrefix) ){
				try {
					var da_name = top.sessionData.pbxinfo.disa[args[0]].label || args[0] ;
				} catch(err) {
					vm_name = 'Error'
				}
				return 'Goto DISA -- ' + da_name ;
			};
			if( args[0] == ASTGUI.contexts.VoiceMailGroups ){
				var t = top.sessionData.pbxinfo.vmgroups;
				return 'Goto VoiceMail Group -- ' + (( t[args[1]] && t[args[1]]['label']) || args[1] ) ;
			}

			return 'Goto ' + args.join() ;
		},

		showAs : function(q){ // ASTGUI.parseContextLine.showAs(line)
			// expects q as 'extension,priority,Goto(context|extension|1)' or 'Goto(context|extension|1)' or 'Goto(context,extension,1)'
			// or 'extensions,priority,Hangup'
			// returns - "User extension" or 'VoiceMenu extension' or 'Hangup' or 'Busy' or some string - depends on q.
			// use this when you want to represent the action to the user

			var app = ASTGUI.parseContextLine.getApp(q) ;
			var args = ASTGUI.parseContextLine.getArgs(q) ;
			var q_LC = q.toLowerCase();
			var all_LC = app.toLowerCase() ;

			if( all_LC == "macro" ){
				if( args[0] && args[0].contains('trunkdial-failover') && args[1] ){
					var tmp_trunkDetails = ASTGUI.parseContextLine.parseTrunkDialArgument(args[1]);
					var tmp_trunkString = (tmp_trunkDetails.name) ? ' using trunk ' + tmp_trunkDetails.name : ' via ' + tmp_trunkDetails.channel ;
					return 'Dial ' + tmp_trunkDetails.prepend + tmp_trunkString ;
				}
				if( args[0] && args[0].contains('receivefax') && args[1] ){
					return 'Fax2Email--' + args[1] ;
				}
				return 'Run Macro ' + (args[0] || '???');
			}
		
			if( all_LC == "agi" ){
				if( args[0].trim() == 'homeauto.sh' ){
					
					if( args[3].endsWith('1')){
						return 'Enable Wireless Tele Controller ' + args[2].trim();
					}
				
					if( args[3].endsWith('0')){
						return 'Disable Wireless Tele Controller ' + args[2].trim();
					}
				}else{ return (args[0])? 'Execute AGI script <b>' + args[0] + '</b>' :  'Execute AGI script <font color=red>!</font>' };
			
			}
			
			if( all_LC == "answer" ){
				return 'Answer the call'
			}
			
			if( all_LC == "nvfaxdetect" ){
				return 'Listen for fax - ' + args[0] + 'sec'
			}

			if( all_LC == "authenticate" ){
				return 'Authenticate for password ' + ( args[0] || ' ??? ' );
			}

			if( all_LC == "disa" ){
				return 'DISA ' + ( args[0] && ' using password ' + args[0] ) + ( args[1] && ' against context ' + args[1] ) ;
			}

			if( all_LC == "background" ){
				return 'Play ' + (args[0] || '???') + ' & Listen for KeyPress events' ;
			}

			if( all_LC == "playback" ){
				return 'Play ' + (args[0] || '???') + ' & Donot Listen for KeyPress events' ;
			}

			if( all_LC == "waitexten" ){
				return "Wait '"+ args[0] + "' sec for the user to enter an extension";
			}

			if( all_LC == "wait" ){
				return "Pause dialplan execution for '"+ args[0] + "' seconds";
			}

			if( all_LC == "hangup" ){
				return "Hangup call";
			}

			if( all_LC == "echo" ){
				return "do the ECHO test";
			}

			if( all_LC == "busy" ){
				return (args[0]) ? "Play BusyTone for '" + args[0] + "' seconds and Hangup" : 'Play Busy Tone indefinetely' ;
			}

			if( all_LC == "congestion" ){
				return (args[0]) ? "indicate Congestion for '" + args[0] + "' seconds and Hangup" : 'indicate congestion indefinetely' ;
			}

			if( all_LC == "directory" ){
				return 'Directory for ' + ( (args[0] && 'context ' +  args[0] ) || '???');
			}

			if( all_LC == "voicemailmain" ){
				return 'Check VoiceMail';
			}

			if( all_LC == "voicemail" ){
				return 'leave Voicemail for user ' + (args[0] || '???');
			}

			if( all_LC == "setmusiconhold" ){
				return "Set Music-On-Hold class '" + (args[0] || 'default') + "'" ;
			}

			if( all_LC == "meetme" ){
				return 'Goto Conference room ' + (args[0] || '???');
			}


			if( all_LC == "dial" ){
				return 'Dial ' + ( args[0] || '???' );
			}

			if( all_LC == "set" && args[0] && args[0].contains('timeout(digit)') ){
				return "Digit Timeout to " + args[0].afterStr('TIMEOUT(digit)=') + " seconds" ; //  exten => s,n,Set(TIMEOUT(digit)=5);
			}

			if( all_LC == "set" && args[0] && ( args[0].toLowerCase().contains('language()=') || args[0].toLowerCase().contains('channel(language)=') )  ){
				return "Set Language to " + args[0].afterStr(')=').trim() ; //
			}

			if( all_LC == "set" && args[0] && args[0].contains('timeout(response)') ){
				return "Response Timeout to " + args[0].afterStr('TIMEOUT(response)=') + " seconds" ; //  exten => s,n,Set(TIMEOUT(response)=10);
			}

			if( all_LC == "goto" ){
				return this.toKnownContext(args);
			}

			return q;
		},

		parseTrunkDialArgument: function(y){ // usage ASTGUI.parseContextLine.parseTrunkDialArgument(y)
			// expects y as  '${trunk_1}/XXX${EXTEN:X}' OR SIP/user/XXX${EXTEN:X}
			var WhatToDial = '';
			if (!y) {
				return null;
			}
			y = y.trim();
			if( y.beginsWith('${') && y.afterChar('}') ) {
				var trunkname = y.betweenXY('{' , '}');
				var channel = '' // TODO - lookup in globals context on extensions_custom.conf
				WhatToDial = y.afterChar('}');
			} else {
				var u = y.split('/');
				if( u.length > 2 && !y.beginsWith('${') ){ // y is in 'SIP/user/PREFIX_1${EXTEN:1}'
					var trunkname = null ;
					var channel = u[0] + '/' + u[1] ;
					u.splice(0,2);
					WhatToDial = u.join('/'); // take the part after second '/'
				}
			}
			// we expect WhatToDial to be in '1${EXTEN:1}' or in '${EXTEN}' or in '${EXTEN:1}' or in '9${EXTEN}' format or a plain extensin string
			if( WhatToDial.contains('${') ){
				if(!WhatToDial.contains('${EXTEN')){ // if WhatToDial is in some other format that the gui does not understand
					// TODO : replace the above if condition with a regular expression to check for the acceptable formats
					// TODO : THROW ERROR
					return null;
				}
				var prepend = WhatToDial.beforeChar('$') ;
				var extenString = WhatToDial.betweenXY('{','}') ;
				var stripXdigitsfromfront = ( extenString.contains(':') ) ? extenString.afterChar(':') || '0' : '0' ;
			} else { // WhatToDial is a plain extension string such as '911' or 'pari'
				var prepend = WhatToDial ;
				var stripXdigitsfromfront = 'ALL' ;
			}
			return { name : trunkname, channel : channel, prepend : prepend, stripx : stripXdigitsfromfront };
		},
	
		incoming_Action: function(v,field){
			if(typeof field =='string'){
				field = _$(field); 
			}
			$(field).showWithBg();
			switch(v){
				case 'gotoexten':
					ASTGUI.selectbox.populateArray( field ,  top.miscFunctions.getUserDestinations() );
					break;
				case 'gotovm':
					ASTGUI.selectbox.populateArray( field,  top.miscFunctions.getUserVMDestinations(1) );
					break;
				case 'gotomenu':
					ASTGUI.selectbox.populateArray( field ,  top.miscFunctions.getIVRDestinations() );
					break;
				case 'gotoringroup':
					ASTGUI.selectbox.populateArray( field ,  top.miscFunctions.getRGDestinations() );
					break;
				case 'gotomeetme':
					ASTGUI.selectbox.populateArray( field ,  top.miscFunctions.getMeetMeDestinations() );
					break;
				case 'gotoqueue':
					ASTGUI.selectbox.populateArray( field ,  top.miscFunctions.getQueueDestinations() );
					break;
				case 'gotodisa':
					ASTGUI.selectbox.populateArray( field ,  top.miscFunctions.getDISADestinations() );
					break;
				case 'gototbrule':
					ASTGUI.selectbox.populateArray( field , top.miscFunctions.getTBRDestinations() );
					break;
				case 'gotofax':
					ASTGUI.selectbox.populateArray( field ,  top.miscFunctions.getFax2EmailDestinations() );
					break;
				case 'directory':
					$(field).hideWithBg();
					ASTGUI.selectbox.selectOption_Add(field,top.miscFunctions.getDirectoryDestinations());
					break;
				case 'hangup':
					$(field).hideWithBg();
					ASTGUI.selectbox.selectOption_Add(field,ASTGUI.contexts.Hangup);
					break;
				case 'congestion':
					$(field).hideWithBg();
					ASTGUI.selectbox.selectOption_Add(field,ASTGUI.contexts.Congestion);
					break;
			}
		},
	
		check_IBAction: function(v){
			if( v.toLowerCase().contains(ASTGUI.contexts.Directory) ){ // //  if "goto directory " 
				return "directory";
			}
			if( v.contains(ASTGUI.contexts.Default) ){ //  if "is a exten"
				return "gotoexten";
			}
			if( v.contains(ASTGUI.contexts.Voicemail ) ){ //  if "is a voicemail"
				return "gotovm";
			}
			if( v.contains(ASTGUI.contexts.VoiceMenuPrefix ) ){ // //  if "goto voicemenu " 
				return "gotomenu";
			}
			if( v.contains(ASTGUI.contexts.RingGroupPrefix) ){ // //  if "goto ringgroup " 
				return "gotoringroup";
			}
			if( v.contains(ASTGUI.contexts.CONFERENCES) ){ // //  if "goto conference " 
				return "gotomeetme";
			}
			if( v.contains(ASTGUI.contexts.QUEUES) ){ // //  if "goto queue " 
				return "gotoqueue";
			}
			if( v.contains(ASTGUI.contexts.DISAPrefix) ){ // //  if "goto disa " 
				return "gotodisa";
			}
			if( v.contains(ASTGUI.contexts.TimeBasedRulePrefix) ){ // //  if "goto fax " 
				return "gototbrule";
			}
			if( v.contains(ASTGUI.contexts.Fax) ){ // //  if "goto fax " 
				return "gotofax";
			}
			if( v.contains(ASTGUI.contexts.Hangup) ){ // //  if "goto hangup " 
				return "hangup";
			}
			if( v.contains(ASTGUI.contexts.Congestion) ){ // //  if "goto congestion " 
				return "congestion";
			}
		},

		obCallingRule: function(str){ 
			var cr = { };
			cr.actualString = str ;
			cr.pattern = ASTGUI.parseContextLine.getExten(str);
			var macroargs = ASTGUI.parseContextLine.getArgs(str);
			cr.macroname = macroargs[0] ;
			cr.firstpara = macroargs[1];
			cr.limit = macroargs[2];
			var t1 = ASTGUI.parseContextLine.parseTrunkDialArgument( macroargs[3] );
			cr.firstTrunk = t1.name ;
			cr.firstPrepend = t1.prepend ;
			cr.stripdigits_firstTrunk = t1.stripx ;
			cr.trunk = [];
			for(var i=3;i<macroargs.length;i++){
				cr.trunk.push(macroargs[i].betweenXY('{' , '}'));
			}
			return cr;
		}
	},


	resetTheseFields : function( flds ){ // ASTGUI.resetTheseFields(arr) , flds = [ el1, el2 , el_3 ] ; - sets each element to blank value
		if(!ASTGUI.isArray(flds)){ return; }
		var reset_el = function(el){
			var tmp_dfalt = $(el).attr('dfalt');
			switch(el.type){
				case 'text':
					el.value = '';
					if( tmp_dfalt )
						el.value = tmp_dfalt;
					break ;
				case 'password':
					el.value = '';
					break ;
				case 'checkbox':
					el.checked = false;
					if( tmp_dfalt)
						ASTGUI.domActions.checkIf_isAstTrue( el , tmp_dfalt);
					break ;
				case 'radio':
					el.checked = false;
					break ;
				case 'select-one':
					el.selectedIndex = -1;
					if(tmp_dfalt) ASTGUI.selectbox.selectOption(el, tmp_dfalt);
					break ;
				case 'textarea':
					el.value = '';
					if( tmp_dfalt )
						el.value = tmp_dfalt;
					break ;
				default : break ;
			}
		};
		var el;
		for (var i=0; i < flds.length ; i++ ) {
			el = flds[i] ;
			if ( typeof el == 'string'){ el = _$(el) ; }
			el.disabled = false;
			reset_el( el );
		}
	},
	
	resetMenu : function( flds ){ // ASTGUI.resetMenu(arr) , flds = [ el1, el2 , el_3 ] ; - sets each element to blank value
		if(!ASTGUI.isArray(flds)){ return; }
		var reset_el = function(el){
			el.onmouseover = function(){ this.style.backgroundColor='#fa921f'; };
			el.onmouseout = function(){ this.style.backgroundColor='#0096db'; };
		};
		var el;
		for (var i=0; i < flds.length ; i++ ) {
			el = flds[i] ;
			if ( typeof el == 'string'){ el = _$(el) ; }
			reset_el( el );
		}
	},

	selectbox: {
		selectDestinationOption: function(el, dest){ // ASTGUI.selectbox.selectDestinationOption(el,dest)
			// selects a given destination 'dest' in select box el
			// dest could be 'context|extention|priority' or 'context,etension,priority' or 'goto(context,etension,priority)' or 's,n,goto(context,etension,priority)'
			//console.log('We are looking for "' + dest + ' " in the selectbox');
			var args = [];
			if ( typeof el == 'string'){ el = _$(el) ; }
			el.selectedIndex = -1;
			if(!dest){return;}

			if( dest.contains('(') && ( dest.contains(',') || dest.contains('|') ) ){
				ASTGUI.selectbox.selectOption(el , dest);
				return;
			}

			if( !dest.contains('(') && !dest.contains(',') && !dest.contains('|') ) {
				ASTGUI.selectbox.selectOption(el , dest);
				return;
			}

			if(dest.contains('(')){
				var tmp = dest.beforeChar('(');
				if( tmp.contains(',') ){
					args = ASTGUI.parseContextLine.getArgs(dest);
				}else{
					args = ASTGUI.parseContextLine.getArgsArrayFrom_AppWithArgs_String(dest);
				}
			}else{
				if(dest.contains(',') || dest.contains('|') ){
					args = ASTGUI.parseContextLine.getArgsArrayFromArgsString(dest);
				}else{
					args = [dest];
				}
			}

			var args_v = args.join('|') ;
			var args_c = args.join(',') ;
			var dest_args_v = 'Goto('+ args.join('|') + ')';
			var dest_args_c = 'Goto('+ args.join(',') + ')' ;

			for( var i=0; i< el.options.length ; i++ ){
				if( (el.options[i].value == dest_args_v) || (el.options[i].value == dest_args_c) || (el.options[i].value == args_v) || (el.options[i].value == args_c )){
					// the select box option vale could be 'goto(context,exten,priority)' or 'Hangup' or just 'context,exten,priority'
					el.selectedIndex = i;
					return;
				}
			}
		},

		populateArray: function(el, arr){ // arr = [{optionText:'TEXT', optionValue:'VALUE'}, {..}] // ASTGUI.selectbox.populateArray(el,arr);
			if ( typeof el == 'string'){ el = _$(el) ; }
			ASTGUI.selectbox.clear(el);
			try{
				for(var f=0, arr_l = arr.length ; f < arr_l ; f++){
					if ( typeof arr[f] == 'string' || !arr[f].optionText ){
						ASTGUI.selectbox.append( el, arr[f], arr[f] );
					}else{
						ASTGUI.selectbox.append( el, arr[f].optionText, arr[f].optionValue );
					}
				}
			}catch(err){}
		},

		populateAddArray: function(el, arr){ // arr = [{optionText:'TEXT', optionValue:'VALUE'}, {..}] // ASTGUI.selectbox.populateArray(el,arr);
			if ( typeof el == 'string'){ el = _$(el) ; }
			try{
				for(var f=0, arr_l = arr.length ; f < arr_l ; f++){
					if ( typeof arr[f] == 'string' || !arr[f].optionText ){
						ASTGUI.selectbox.append( el, arr[f], arr[f] );
					}else{
						ASTGUI.selectbox.append( el, arr[f].optionText, arr[f].optionValue );
					}
				}
			}catch(err){}
		},

		readAllValues: function(el){
			if ( typeof el == 'string'){ el = _$(el) ; }
			var y = [] ;
			for (var x=0; x < el.options.length; x++) {
				if(el.options[x].value.trim()){
					y.push(el.options[x].value) ;
				}
			}
			return y;
		},

		populateOptions: function( el, s, n){
			if ( typeof el == 'string'){ el = _$(el) ; }
			n = Number(n);
			s = Number(s),
			ASTGUI.selectbox.clear(el);
			var m = ASTGUI.selectbox.append;
			for ( var i=s ; i <= n ; i++) { m(el, i, i); }
		},

		insert_before: function(el,txt, val, i){ // ASTGUI.selectbox.insert_before(el,txt, val, i);
			if ( typeof el == 'string'){ el = _$(el) ; }
			if($.browser.msie){
				el.add(new Option (txt,val), i );
			}else{
				el.add(new Option (txt,val), el.options[i] );
			}
		},

		insertOption_before: function(el,opt, i){
			if ( typeof el == 'string'){ el = _$(el) ; }
			if($.browser.msie){
				el.add(opt, i );
			}else{
				el.add(opt, el.options[i] );
			} 
		},

		append: function(el,txt, val){ // ASTGUI.selectbox.append(el,txt,val);
			if ( typeof el == 'string'){ el = _$(el) ; }
			el.options[el.options.length] = new Option (txt,val);
		},

		append_option: function(el,opt){
			if ( typeof el == 'string'){ el = _$(el) ; }
			if($.browser.msie){
				el.add(opt);
			}else{
				el.add(opt,null);
			}
		},

		remove_i: function(el, i){
			if ( typeof el == 'string'){ el = _$(el) ; }
			el.options[i] = null;
		},
	
		clear: function(el){
			if ( typeof el == 'string'){ el = _$(el) ; }
			el.options.length = 0;
		},

		selectOption: function(el, opt){ // ASTGUI.selectbox.selectOption(el,opt)
			if ( typeof el == 'string'){ el = _$(el) ; }
			el.selectedIndex = -1;
			for (var x=0; x < el.options.length; x++) {
				if (el.options[x].value == opt){
					el.selectedIndex = x;
				}
			}
		},

		selectOption_Add : function(el, opt){ // adds opt as new options if it is not already found 
			if ( typeof el == 'string'){ el = _$(el) ; }
			el.selectedIndex = -1;
			for (var x=0; x < el.options.length; x++) {
				if (el.options[x].value == opt){
					el.selectedIndex = x;
				} 
			}
			if(el.selectedIndex == -1){
				ASTGUI.selectbox.append(el, opt, opt);
				ASTGUI.selectbox.selectOption(el, opt);
			}
		}
	}, // { selectbox }

	showToolTips : function(){
		if(window.jQuery && $.tooltip){
			$('img.tooltipinfo').tooltip({delay:0.5,showURL:false,fixPNG:true,showBody:" - ",extraClass:"pretty fancy",top:-35,left:10});
		}
	},

	sortContextByExten: function(cxt , getAll){ // ASTGUI.sortContextByExten( cxt , boolean); 
		// if boolean set to false or null or undefined --> consider only 's' & interger extensions
		// if boolean set to true --> get every pattern

		/* goal is to sort a context array as sorted by asterisk dialplan (almost)
			Ex: ['exten=s,2,App2','exten=s,1,App1','exten=1,1,App', 'exten=s,n,AppN'] 
				will be converted to 

			{
				s:['s,1,App1','s,2,App2','s,3,AppN'], //each extension will be sorted
				1:['1,1,App']
			}
			This function is help ful when you try to represent a set of context lines in order in the GUI Ex: in VoiceMenus
			WARNING: ******* this function attempts to convert 'n' priority to a number ****
		*/

		var TO_RETURN = {}, EXTENSIONS = {};
		cxt.each( function(line , cxt_index) {
			if( !line.beginsWith('exten=') ) return;
			var exten = ASTGUI.parseContextLine.getExten(line);
			if( !getAll && isNaN(exten) && exten !='s' ) return; // we only handle numbers and 's' at this time
			if( ! EXTENSIONS.hasOwnProperty(exten) ){
				EXTENSIONS[exten] = [] ;
			}
			EXTENSIONS[exten].push(line) ;
		} );
		
		// sorting to make sure we return in the right order
		for( var THIS_EXTEN in EXTENSIONS ){ if(EXTENSIONS.hasOwnProperty(THIS_EXTEN) ){
			TO_RETURN[THIS_EXTEN] = [];
			var TMP_CONTEXT = EXTENSIONS[THIS_EXTEN];
			TMP_CONTEXT.each( function(line, line_index){
				var priority = ASTGUI.parseContextLine.getPriority(line);
				if( priority == 'n' ){
					var new_Priority = Number(ASTGUI.parseContextLine.getPriority(TMP_CONTEXT[line_index-1])) + 1 ;
					if( TO_RETURN[THIS_EXTEN].indexOfLike( THIS_EXTEN + ','+ new_Priority + ',' ) == -1 ){
						var new_line = THIS_EXTEN + ',' + new_Priority + ',' + ASTGUI.parseContextLine.getAppWithArgs(line);
						TO_RETURN[THIS_EXTEN].push(new_line);
					}
					return;
				}else{
					priority = Number( priority ) ;
					for(var g=0; g < TO_RETURN[THIS_EXTEN].length ; g++ ){
						var tmp_priority = Number( ASTGUI.parseContextLine.getPriority( TO_RETURN[THIS_EXTEN][g] ) );
						if( priority < tmp_priority ){
							TO_RETURN[THIS_EXTEN].splice(g,0, line.afterChar('=') );
							return;
						}
					}
					TO_RETURN[THIS_EXTEN].push( line.afterChar('=') );
				}
				return true ;
			});
		}}
		return TO_RETURN;
	},

	systemCmd: function(cmd, callbackfunction, sync){ // ASTGUI.systemCmd(cmd, cbf);
		if(sync){ cmd = cmd + ';sync' };  //add sync fix nand issues
//		ASTGUI.Log.Debug("Executing System Command : '" + cmd + "'" );
		var password = encodeURIComponent(top.ASTGUI.cookies.getCookie('password'));
		$.ajax({
			url: ASTGUI.paths.run_system_cmd,
			method: 'get',
			cache: false,
			data: 'username='+top.ASTGUI.cookies.getCookie('username')+'&password='+password+'&cmd='+cmd,
			success: function(response) {
				callbackfunction() ;
//				top.document.getElementById('ajaxstatus').style.display = '';
			}
		});
	},

	systemCmdWithOutput: function(cmd, callbackfunction, sync) {
		// usage :: ASTGUI.systemCmdWithOutput( 'uptime' , callback(output){ /* do something with output */ } );
		// Use this function when you want to execute a specific system command and read the output
		// output will be sent as a argument to the callback function
		if(sync){ cmd = cmd + '; sync' }; //add sync fix nand issues
		var password = encodeURIComponent(top.ASTGUI.cookies.getCookie('password'));
		$.ajax({
			url: ASTGUI.paths.run_system_cmd,
			method: 'get',
			cache: false,
			data: 'username='+top.ASTGUI.cookies.getCookie('username')+'&password='+password+'&cmd='+cmd,
			success: function(response) {
				callbackfunction( response.trim() ) ;
				top.document.getElementById('ajaxstatus').style.display = '';
			}
		});
	},

	toLocalTime: function (k){ // Converts the UTC time read on the appliance to the browsers local time
		// expects k as 'Fri Dec  8 23:59:59 UTC 2008'
		try{
			var tmp = k.split(" ");
			if(tmp[2] == ""){ tmp.splice(2,1) ; }
			// tmp[0] = 'Fri' , tmp[1] ='Dec', tmp[2] = '8', tmp[3] = '23:59:59', tmp[4]= 'always assume UTC', tmp[5] = '2008'
			var temp = tmp[3].split(':'); // hours =  parseInt(temp[0]), minutes = parseFloat(temp[1]);
			// convert these values to local time
			var months_strings = ["jan", "feb", "mar", "apr", "may", "jun", "jul", "aug","sep","oct","nov","dec"];
			var day_strings = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
			var month_no = months_strings.indexOf(tmp[1].toLowerCase());
	
			var utc_date = new Date();
			utc_date.setUTCFullYear ( tmp[5] , month_no , tmp[2] );
			utc_date.setUTCHours ( parseInt(temp[0]), parseInt(temp[1]) );
		
			var lt_hours = utc_date.getHours(); // 0 to 23
			var lt_minutes = utc_date.getMinutes(); // 0 to 59
			var lt_month = months_strings[utc_date.getMonth()]; // 0 to 11
			var lt_dom = utc_date.getDate(); // 1 to 31
			var lt_year = utc_date.getFullYear() ; // 2007
			var lt_day = day_strings[utc_date.getDay()] ; // 0 to 6
		
			return lt_day + " " + lt_month + " " + lt_dom + ", " + lt_hours + ":" + lt_minutes + " " + lt_year;
		}catch(err){
			return '';
		}
	},

	updateaValue: function(e){
		// ASTGUI.updateaValue(  {file:'users.conf', context :'6000', variable :'hassip', value :'yes'}   )
		var u = new listOfSynActions(e.file) ;
		u.new_action('update', e.context, e.variable , e.value );
		var g = u.callActions();
		return (g.contains('Response: Success')) ? true : false ;
	},

	updateFieldToValue : function( el, val ){ // updates a field el, to value 'val' - el could be a text box, select-option, or a checkbox
		// ASTGUI.updateFieldToValue(el,val)
		if ( typeof el == 'string'){ el = _$(el) ; }
		var tmp_dfalt = $(el).attr('dfalt');

		switch(el.type){
			// TODO come up with a way to handle radio buttons
			case 'hidden':
			case 'password':
			case 'text':
				el.value = val ;
				if( tmp_dfalt && !val ) el.value = tmp_dfalt;
				break ;
			case 'textarea':
				el.value = val ;
				if( tmp_dfalt && !val ) el.value = tmp_dfalt;
				break ;	
			case 'checkbox':
				ASTGUI.domActions.checkIf_isAstTrue( el , val);
				if( tmp_dfalt && ( typeof val == 'undefined' || val == '' ) ){
					ASTGUI.domActions.checkIf_isAstTrue( el , tmp_dfalt);
				}
				break;
			case 'radio':
				ASTGUI.Log.Error('You are on your own with Radio Buttons');
				break ;
			case 'select-one':
				ASTGUI.selectbox.selectOption(el, val);
				if( tmp_dfalt && !val ) ASTGUI.selectbox.selectOption(el, tmp_dfalt);
				break;
			default:
				break;
		}
		return;
	},

	highlightField: function( field , msg ){ // ASTGUI.highlightField( field, msg );
		if(typeof field =='string'){ field = _$(field); }
		var pcn = field.className || '' ;
		if(msg){
			 ASTGUI.feedback({ msg: msg, showfor: 5,color: "#FFF" });
		}
		field.className = 'inputValidationFailed';
		setTimeout( function(){ field.className = pcn; } , 4500 );
		try{ field.focus(); }catch(e){ }
	},

	validateFields : function( fields ){ // ASTGUI.validateFields ( [ 'field_x' , el_x ] );
		for(var g=0; g < fields.length ; g++ ){
			var field = fields[g];
			if(typeof field =='string'){ field = _$(field); }
			var validation = $(field).attr('validation') ;
			if(!validation){ continue; }
			var this_field_name = $(field).attr('field_name') ;
			var x = field.value ;
			var pcn = ( field.className ) ? field.className : '' ;

			switch(validation){
				case 'numeric':
					// check if field's value is numeric - otherwise highlight field and return false
					var fb_msg = (this_field_name) ? this_field_name + ' is a numeric field. Letters and Punctuation are not allowed in this field.' : 'This is a numeric field. Letters are not allowed in this field.';
					if ( /[^0-9]/.test(x) ){
						ASTGUI.highlightField( field, fb_msg );
						return false;
					}
					break;
				case 'numeric_plus':
					// check if field's value is numeric - otherwise highlight field and return false
					var fb_msg = (this_field_name) ? this_field_name + ' is a numeric field. Letters are not allowed in this field.' : 'This is a numeric field. Letters are not allowed in this field.';
					if ( /[^0-9\+]/.test(x) ){
						ASTGUI.highlightField( field, fb_msg );
						return false;
					}
					break;
				case 'numeric_plus_w':
					// check if field's value is numeric - otherwise highlight field and return false
					var fb_msg = (this_field_name) ? this_field_name + ' is a numeric only field.' : 'This is a numeric only field.';
					if ( /[^0-9w\+]/.test(x) ){
						ASTGUI.highlightField( field, fb_msg );
						return false;
					}
					break;
				case 'alphanumeric':
					if ( /[^a-zA-Z0-9]/.test(x) ){
						var fb_msg = (this_field_name) ? this_field_name + ' is a AlphaNumeric only field' : 'This is a AlphaNumeric only field.';
						ASTGUI.highlightField( field, fb_msg );
						return false;
					}
					break;
				case 'alphanumericUnd':
					var fb_msg = (this_field_name) ? this_field_name + ' is a AlphaNumeric only field.' : 'This is a AlphaNumeric only field.';
					if ( /[^a-zA-Z_0-9]/.test(x) ){
						ASTGUI.highlightField( field, fb_msg );
						return false;
					}
					break;
				case 'alphanumericUndSpace':
					var fb_msg = (this_field_name) ? this_field_name + ' is a AlphaNumeric only field.' : 'This is a AlphaNumeric only field.';
					if ( /[^a-zA-Z_0-9 ]/.test(x) ){
						ASTGUI.highlightField( field, fb_msg );
						return false;
					}
					break;
				case 'dialpattern':
					var fb_msg = (this_field_name) ? 'Invalid Characters in ' + this_field_name  : 'Invalid character in a Dial Pattern field.';
					if ( /[^a-zA-Z_0-9\.!*#\[\]\-\+]/.test(x) ){
						ASTGUI.highlightField( field, fb_msg );
						return false;
					}
					break;
				case 'macaddress':
					var fb_msg = (this_field_name) ? this_field_name + ' is a MAC address field. Only HEX characters are allowed.' : 'This is a MAC address field. Only HEX characters are allowed.';
					if ( /[^a-fA-F0-9:\-]/.test(x) ){
						ASTGUI.highlightField( field, fb_msg );
						return false;
					}
					/*
					if ( x.trim() && x.length != 12 ){
						ASTGUI.highlightField( field, 'invalid MAC address !.<br /> MAC address should be 12 digits long.');
						return false;
					}
					*/
					break;
				case 'voipusername':
					var fb_msg = 'Punctuation and Special Characters are not allowed in this field.' ;
					if ( /[^a-zA-Z_0-9\.]/.test(x) ){
						ASTGUI.highlightField( field, fb_msg );
						return false;
					}
					break;
				default:
					break;
			}
		}
		return true;
	},
	
	yesOrNo : function(yn){
		// yn = { msg:'' , ifyes: function(){} , ifno: fn (optional), btnYes_text :'Yes' (optional), btnNo_text :'No'(optional) }
		// ASTGUI.yesOrNo ( {msg: 'dddddd', ifyes:function(){alert("Yes");} ,  ifno:function(){alert("No");} , hideNo: true, dialogWidth:490, dialogHeight:290 } );
		var dv = document.createElement("DIV");
		dv.className = 'yes_no_dialog' ;
		var WindowSize = top.document.getElementById('mainscreen').height; //store height of current window
		ReSizeIframeTo(200);
				
		var dv_header_row = document.createElement("DIV");
		dv_header_row.style.backgroundColor = "#333333";
		dv_header_row.style.height = "5px";
		dv.appendChild(dv_header_row);
		
		(function(){
			var dv_q = document.createElement("TABLE");
			dv_q.style.width = '100%';

			var newRow = dv_q.insertRow(-1);
			ASTGUI.domActions.tr_addCell( newRow , { html: yn.msg, align: 'center', valign:'middle', height: '70' } );

			var newRow2 = dv_q.insertRow(-1);
			var newcell2 = newRow2.insertCell( newRow2.cells.length );
			newcell2.align = 'center';
			newcell2.valign = 'bottom';
			newcell2.height = '55';
			var btnYES = document.createElement("button");
			btnYES.innerHTML = (yn.btnYes_text)? yn.btnYes_text : 'Yes' ;
			btnYES.style.marginRight='5px';
			ASTGUI.events.add( btnYES , 'click' , function() {
				dv.parentNode.removeChild(dv);
				ReSizeIframeTo(WindowSize); //reset height
				yn.ifyes();
			});
			var btnNo = document.createElement("button");
			btnNo.innerHTML = ( yn.btnNo_text ) ? yn.btnNo_text : 'No' ;
			btnNo.style.marginRight='5px';
			ASTGUI.events.add( btnNo , 'click' , function() {
				dv.parentNode.removeChild(dv);
				ReSizeIframeTo(WindowSize); //reset height
				if( yn.ifno ){ yn.ifno(); }
			});
			if( !yn.hideYes ){ newcell2.appendChild( btnYES ) };
			if( !yn.hideNo ){ newcell2.appendChild(btnNo) };
			dv.id = 'yes_no_dialog';
			dv.appendChild(dv_q);
		})();
		setTimeout(function(){ //slow down for chrome
				top.document.getElementById('menu').style.display = '';
				dv.style.width = top.document.getElementById('menu').offsetWidth + 'px';
				dv.style.height = (210 + top.document.getElementById('menu').offsetHeight) + 'px';
				dv.style.left = findPosX(top.document.getElementById('menu')) + 'px';
				dv.style.top = findPosY(top.document.getElementById('menu')) + 'px';
				document.body.appendChild(dv);
			}
		,150); 
	},
	displayHeight: function(){

		if(isIE){return document.body.clientHeight;}else{return window.innerHeight;}

	},
	chgExtension: function(a){
		if( !a ){ return ''; }
		if(a.contains(".")){
			var b = a.lastIndexOf(".");
			return a.substr(0,b+1) + a.substr(b+1).toLowerCase();
		}
		return a;
	},
	chop_Extension: function(a){
		if( !a ){ return ''; }
		if( a.endsWith('.gsm') ){ return a.rChop('.gsm'); }
		else if( a.endsWith('.wav') ){ return a.rChop('.wav'); }
		else if( a.endsWith('.alaw') ){ return a.rChop('.alaw'); }
		else if( a.endsWith('.g722') ){ return a.rChop('.g722'); }
		else if( a.endsWith('.g729') ){ return a.rChop('.g729'); }
		else if( a.endsWith('.ulaw') ){ return a.rChop('.ulaw'); }
		return a;
	}
}; // ( AstGUI )

ASTGUI.paths = {};

ASTGUI.paths['guiInstall'] = '/www/';
ASTGUI.paths['rawman'] = '/AMI/rawman';
ASTGUI.paths['asteriskConfig'] = '/etc/asterisk/';
ASTGUI.paths['systemimage'] = '/tmp/';
ASTGUI.paths['ConfigBkp'] = '/www/gui_backups/';
ASTGUI.paths['ConfigBkp_dldPath'] = ASTGUI.paths['guiInstall'] + 'private/bkps/'; // path for keeping the bkp files for download
ASTGUI.paths['Recordings_dldPath'] = ASTGUI.paths['guiInstall'] + 'private/recordings/';
ASTGUI.paths['AGIBIN'] = '/var/lib/asterisk/agi-bin/';
ASTGUI.paths['Sounds'] = '/var/lib/asterisk/sounds/';
ASTGUI.paths['MOH'] = '/sounds/moh/'; // path for music on hold files
ASTGUI.paths['menusRecord'] = '/var/lib/asterisk/prompts/';
ASTGUI.paths['listpatch'] = '/patch/';
ASTGUI.paths['OVpnServerKyes'] = '/etc/openvpn/keys/';
ASTGUI.paths['OVpnServerDownload'] = '/www/openvpnkeys/';
ASTGUI.paths['OVpnClientKyes'] = '/etc/openvpn/clientkeys/';
ASTGUI.paths['pinset'] = ASTGUI.paths['asteriskConfig'] + 'pinset/';
ASTGUI.paths['recordings'] = '/var/spool/asterisk/monitor/recording/';
ASTGUI.paths['onetouch'] = '/var/spool/asterisk/monitor/one_touch/';
ASTGUI.paths['meetme'] = '/var/spool/asterisk/monitor/meetme/';
ASTGUI.paths['faxs'] = '/var/spool/asterisk/fax/';
ASTGUI.paths['sendfax'] = '/tmp/fax/';
ASTGUI.paths['tmp'] = '/tmp/';
ASTGUI.paths['syslogs'] = '/www/log/syslogs/';
ASTGUI.paths['master_cdr'] = 'cdr-csv/Master.csv';
ASTGUI.paths['scripts'] = '/etc/scripts/';/* Directory for gui scripts (listfiles, for example) */	
ASTGUI.paths['output_SysInfo'] = './sysinfo_output.html' ;
ASTGUI.paths['run_system_cmd'] = './cgi-bin/system_cmd.cgi' ;
ASTGUI.paths['voicemails_dir'] = '/var/spool/asterisk/voicemail/default/' ;

ASTGUI.scripts = {};
ASTGUI.scripts['down_users_extensions'] = ASTGUI.paths['scripts'] + 'down_users_extensions' ;
ASTGUI.scripts['bulk_users_gen'] = ASTGUI.paths['scripts'] + 'bulk_users_gen ';
ASTGUI.scripts['syslogs'] = 'sh ' + ASTGUI.paths['scripts'] + 'logger.sh';
ASTGUI.scripts['emailtofax'] = 'sh ' + ASTGUI.paths['scripts'] + 'emailtofax.sh save';
ASTGUI.scripts['sendtest'] = 'sh ' + ASTGUI.paths['scripts'] + 'faxtoemail.sh ';
ASTGUI.scripts['vpnusers'] = 'sh ' + ASTGUI.paths['scripts'] + 'vpnusers.sh';
ASTGUI.scripts['vpnclient'] = 'sh ' + ASTGUI.paths['scripts'] + 'vpnclient.sh';
ASTGUI.scripts['vpnserver'] = 'sh ' + ASTGUI.paths['scripts'] + 'vpnserver.sh';
ASTGUI.scripts['openvpnkey'] = 'sh ' + ASTGUI.paths['scripts'] + 'openvpnkey.sh ';
ASTGUI.scripts['snmpsettings'] = 'sh ' + ASTGUI.paths['scripts'] + 'snmp.sh';
ASTGUI.scripts['runddns'] = 'sh ' + ASTGUI.paths['scripts'] + 'runddns.sh';
ASTGUI.scripts['dhcpd'] = 'sh ' + ASTGUI.paths['scripts'] + 'dhcpd_conf.sh';
ASTGUI.scripts['tr069'] = 'sh ' + ASTGUI.paths['scripts'] + 'tr069.sh';
ASTGUI.scripts['service'] = 'sh ' + ASTGUI.paths['scripts'] + 'service.sh';
ASTGUI.scripts['phonesinit'] = ASTGUI.paths['scripts'] + 'phonesinit.sh';
ASTGUI.scripts['firewall'] = ASTGUI.paths['scripts'] + 'firewall.sh';
ASTGUI.scripts['mymd5'] = ASTGUI.paths['scripts'] + 'mymd5.sh ';
ASTGUI.scripts['storage_check'] = ASTGUI.paths['scripts'] + 'storage.sh check';
ASTGUI.scripts['storage_enable'] = ASTGUI.paths['scripts'] + 'storage.sh enable';
ASTGUI.scripts['storage_disable'] = ASTGUI.paths['scripts'] + 'storage.sh disable';
ASTGUI.scripts['storage_now'] = ASTGUI.paths['scripts'] + 'data_backup.sh';
ASTGUI.scripts['pnpsettings'] = ASTGUI.paths['scripts'] + 'pnp.sh';
ASTGUI.scripts['shell'] = 'sh ' + ASTGUI.paths['scripts'] + 'shell_scripts.sh';
ASTGUI.scripts['logspackage'] = ASTGUI.paths['scripts'] + 'logspackage.sh ';
ASTGUI.scripts['network'] = ASTGUI.paths['scripts'] + 'network.sh start';
ASTGUI.scripts['getdhcpcinfo'] = ASTGUI.paths['scripts'] + 'getdhcpcinfo.sh';
ASTGUI.scripts['phonebookimport'] = ASTGUI.paths['scripts'] + 'phonebook.sh import ';
ASTGUI.scripts['phonebookexport'] = ASTGUI.paths['scripts'] + 'phonebook.sh export ';
ASTGUI.scripts['Backup'] = ASTGUI.scripts['shell'] + ' backup ';
ASTGUI.scripts['restore_all'] = ASTGUI.scripts['shell'] + ' restore_all ';
ASTGUI.scripts['restore_pbx'] = ASTGUI.scripts['shell'] + ' restore_pbx ';
ASTGUI.scripts['restore_network'] = ASTGUI.scripts['shell'] + ' restore_network ';
ASTGUI.scripts['setdefault'] = ASTGUI.scripts['shell'] + ' reset_config';
ASTGUI.scripts['setdefault_withoutnetwork'] = ASTGUI.scripts['shell'] + ' reset_config_without_net';
ASTGUI.scripts['no_setdefault'] = ASTGUI.scripts['shell'] + ' no_reset';
ASTGUI.scripts['upgrade_reboot'] = ASTGUI.scripts['shell'] + ' upgrade_reboot';
ASTGUI.scripts['tftp_upgrade'] = ASTGUI.scripts['shell'] + ' tftp_upgrade ';
ASTGUI.scripts['wgetsounds'] = ASTGUI.scripts['shell'] + ' wget_sounds ';
ASTGUI.scripts['pingstart'] = ASTGUI.scripts['shell'] + ' pingstart ';
ASTGUI.scripts['pingstop'] = ASTGUI.scripts['shell'] + ' pingstop ';
ASTGUI.scripts['traceroutestart'] = ASTGUI.scripts['shell'] + ' traceroutestart ';
ASTGUI.scripts['traceroutestop'] = ASTGUI.scripts['shell'] + ' traceroutestop ';
ASTGUI.scripts['cleanextenlog'] = ASTGUI.scripts['shell'] + ' cleanextenlog ';
ASTGUI.scripts['cleancalllog'] = ASTGUI.scripts['shell'] + ' cleancalllog ';
ASTGUI.scripts['cleanstoragelog'] = ASTGUI.scripts['shell'] + ' cleanstoragelog ';
ASTGUI.scripts['routingtable'] = ASTGUI.scripts['shell'] + ' routing_table';
ASTGUI.scripts['smtpset'] = ASTGUI.scripts['shell'] + ' smtpset';
ASTGUI.scripts['ListFiles'] = ASTGUI.scripts['shell'] + ' list_files';
ASTGUI.scripts['ListDirs'] = ASTGUI.scripts['shell'] + ' list_dirs';
ASTGUI.scripts['sip_permit'] = ASTGUI.scripts['shell'] + ' sip_permit';
ASTGUI.scripts['setchans'] = ASTGUI.scripts['shell'] + ' setchans';
ASTGUI.scripts['ListFilesWithExtension'] = ASTGUI.scripts['shell'] + ' list_files_with_extension';
ASTGUI.scripts['ListFilesSize'] = ASTGUI.scripts['shell'] + ' list_files_size';
ASTGUI.scripts['ListFilesAndSubs'] = ASTGUI.scripts['shell'] + ' list_files_andsub';
ASTGUI.scripts['generateDAHDI'] = ASTGUI.scripts['shell'] + ' edit_dahdi';
ASTGUI.scripts['generatemISDN_init'] = ASTGUI.scripts['shell'] + ' edit_misdn';
ASTGUI.scripts['br4'] = ASTGUI.scripts['shell'] + ' br4_check' ;
ASTGUI.scripts['pr1_check'] = ASTGUI.scripts['shell'] + ' pr1_check' ;
ASTGUI.scripts['dhcpd_check'] = ASTGUI.scripts['shell'] + ' dhcpd_check';
ASTGUI.scripts['dhcpd_enable_or_disable'] = ASTGUI.scripts['shell'] + ' dhcpd_enable_or_disable';
ASTGUI.scripts['dyndns_check'] = ASTGUI.scripts['shell'] + ' dyndns_check';
ASTGUI.scripts['dyndns_enable_or_disable'] = ASTGUI.scripts['shell'] + ' dyndns_enable_or_disable';
ASTGUI.scripts['Reset_Configs'] = ASTGUI.scripts['shell'] + ' reset_config' ;
ASTGUI.scripts['mastercsv_exists'] = ASTGUI.scripts['shell'] + ' mastercsv_exists';
ASTGUI.scripts['GSM_Check'] = ASTGUI.scripts['shell'] + ' GSM_Check';   
ASTGUI.scripts['check_upgrades'] = ASTGUI.scripts['shell'] + ' check_upgrades';
ASTGUI.scripts['IPTables_Check'] = ASTGUI.scripts['shell'] + ' IPTables_Check';
ASTGUI.scripts['LAN_Check'] = ASTGUI.scripts['shell'] + ' LAN_Check';
ASTGUI.scripts['WLTC_Check'] = ASTGUI.scripts['shell'] + ' WLTC_Check';
ASTGUI.scripts['WLRR_List'] = ASTGUI.scripts['shell'] + ' WLRR_List';
ASTGUI.scripts['dldsoundpack'] = 'sh ' + ASTGUI.paths['scripts'] + 'dldsoundpack.sh'

ASTGUI.apps = {};
ASTGUI.apps['reboot'] = 'reboot';
ASTGUI.apps['datesaved'] = 'hwclock -w';
ASTGUI.apps['remove'] = '/bin/rm -rf ';
ASTGUI.apps['touch'] = '/bin/touch ';
ASTGUI.apps['cat'] = 'cat ';
ASTGUI.apps['dhcpclist'] = 'dumpleases';
ASTGUI.apps['iptablescmd'] = '/etc/scripts/iptables.sh ';
ASTGUI.apps['iptables'] = 'iptables ';
ASTGUI.apps['iptablesSaved'] = 'iptables-save /etc/asterisk/iptables.save';
ASTGUI.apps['DAHDIscan'] = ASTGUI.scripts['shell'] + ' dahdi_scan ' + ASTGUI.paths['asteriskConfig'] +'dahdi_scan.conf' ;
ASTGUI.apps['mISDNscan'] = 'cat /etc/asterisk/br4.conf' ;
ASTGUI.apps['flashupdate'] = 'flashupdate' ;

var isIE = false;

if(document.attachEvent){ isIE= true; }

ASTGUI.customObject.prototype = {
	getProperty: function(p){
		return (this.hasOwnProperty(p))? this[p] : '' ;
	},
	updateProperties: function(prop){
		for( var g in prop ){
			if( prop.hasOwnProperty(g) ){
				this[g] = prop[g];
			}
		}
	},
	getOwnProperties: function(){
		var a = [] ;
		for( var i in this ) {
			if ( this.hasOwnProperty(i) ){
				a.push(i) ;
			}
		}
		return a ;
	}
};

var makeRequest = function( params){ // for making Asynchronus requests
	// usage ::  makeRequest ( { action :'getconfig', filename: 'something.conf', callback:callbackfunction() } )
	var cb = params.callback ; delete params.callback;
	if( params.action == "updateconfig" ){
		params.srcfilename = params.filename;
		params.dstfilename = params.filename;
		if(top.sessionData.DEBUG_MODE ){ASTGUI.Log.Ajax("AJAX Request : '" + ASTGUI.getObjectPropertiesAsString(params) + "'" );}
		delete params.filename;
	}else{
		if(top.sessionData.DEBUG_MODE ){ASTGUI.Log.Ajax("AJAX Request : '" + ASTGUI.getObjectPropertiesAsString(params) + "'" );}
	}

	$.get(ASTGUI.paths.rawman, params, cb);
}; // ( makeRequest )

var makeSyncRequest = function( params){ // for making synchronus requests
	// usage ::  makeSyncRequest ( { action :'getconfig', filename: 'something.conf' } ) // no need for call back function
//	if(top.sessionData.DEBUG_MODE ){ASTGUI.Log.Ajax("AJAX Request : '" + ASTGUI.getObjectPropertiesAsString(params) + "'" );}
	var s = $.ajax({ url: ASTGUI.paths.rawman, data: params , async: false });
	return s.responseText;
};


var context2json = function(params){ 
	// usage :: context2json({ filename:'something.conf' , context : 'context_1' , usf:0 })
	// get a specific context from a file
	// you can also use config2json - but if you want to save that 20ms wasted for 
	// parsing all those other contexts you are not inrested in, use this.
	// TODO use 'getconfig with a specific context' when running on supported asterisk versions
	var toJSO = function(z){
		var cat = (params.usf) ? new ASTGUI.customObject : [] ;
		var t = z.split("\n");
		var catno = -1 ;
		var l_catno , catname , tlc , subfield , v, subfield_a, subfield_b;
		var catfound = false;
		for(var r=0, tl =  t.length ; r < tl ; r++){
			tlc = t[r].toLowerCase();
			if( tlc.beginsWith("category-") ){
				catname = t[r].afterChar(':');
				catname = catname.trim() ;
				if( catname != params.context){ catno = -1; continue; }
				catno = Number( t[r].betweenXY('-', ':') );
				catfound = true;
			}
			if( catno == -1 ){ continue; }
			if( tlc.beginsWith("line-") ){
				var l_catno = Number( t[r].betweenXY('-','-') );
				if( l_catno != catno ){ continue; }

				subfield = t[r].afterChar(':'); // subfield
				subfield = subfield.trim();
				if(params.usf){
					v = subfield.indexOf('=');
					subfield_a = subfield.substring(0,v);//subfield variable
					subfield_b =  subfield.substr(v+1) ;//subfield variable value
					if( cat.hasOwnProperty(subfield_a) ){
						cat[subfield_a] += ',' + subfield_b ;
					}else{
						cat[subfield_a] = subfield_b;
					}
				}else{
					cat.push( subfield );
				}
			}
		}
		return (catfound)?cat : null ;
	};

	ASTGUI.Log.Ajax("AJAX Request : reading '" +  params.filename + "'" );

	if( top.sessionData.FileCache.hasOwnProperty(params.filename) &&  top.sessionData.FileCache[params.filename].modified == false){ // if file is in cache and is not modified since
		var s = top.sessionData.FileCache[params.filename].content ;
	}else{
		var s = $.ajax({ url: ASTGUI.paths.rawman+'?action=getconfig&filename='+params.filename+'&category='+params.context, async: false }).responseText;

		top.sessionData.FileCache[params.filename] = {};
		top.sessionData.FileCache[params.filename].content = s;
		top.sessionData.FileCache[params.filename].modified = false;
	}

	if(s.contains('Response: Error') && ( s.contains('Message: Config file not found') || s.contains('Message: Permission denied') ) ){
		// return ASTGUI.globals.fnf; // return 'file not found'
		if(s.contains('Message: Config file not found'))
			ASTGUI.Log.Error( ' config file(' + params.filename +') not found ' );	
		if(s.contains('Message: Permission denied'))
			ASTGUI.Log.Error('permission denied for reading file ' + params.filename );

		return (params.usf) ? new ASTGUI.customObject : [] ;
	}
	if( s.contains('Response: Error') ){
		return (params.usf) ? new ASTGUI.customObject : [] ;
	}
	return toJSO(s);
};

var config2json = function( params ){
	// usage :: config2json({filename:'something.conf', usf:0 }) or config2json({filename:'users.conf', catlist:'yes'})
	//	config2json({ configFile_output: output_string , usf:0 }) // you can also pass the output of a config file
	var toCATLIST = function(z){
		var a = [ ], catname = '' ;
		var t = z.split("\n");
		for(var r=0, tl =  t.length ; r < tl ; r++){
			if( t[r].toLowerCase().beginsWith("category") ){
				catname = t[r].afterChar(':'); // category 
				a.push( catname.trim() );
			}
		}
		return a;
	};
	var toJSO = function(z){
		// This function converts z, the asterisk config file as read using 'action=getconfig' to a JavaScript Object 
		// where z is originalRequest.responseText of the getconfig on a asterisk format config file, 
		// and p is 0 or 1, 
		//	 0 for non unique subfields ( extensions_custom.conf context where there are multiple subfields with same name - -  Ex: 'exten ='   )
		//	 1 for unique subfields ( config files where there are no two subfields of a context have same name )
		//  if not sure ,  use p = 0 
		var p = params.usf;
		var a = new ASTGUI.customObject ;
		var json_data = "";
		var t = z.split("\n");
		var catname, subfield, v, subfield_a , subfield_b; 
		for(var r=0, tl =  t.length ; r < tl ; r++){
			if( t[r].toLowerCase().beginsWith("category") ){
				catname = t[r].afterChar(':'); // category 
				catname = catname.trim() ;
				if(!a[catname]){ // contexts could be spread at different places in the config file
					if(!p){
						a[catname] = [];
					}else{
						a[catname] = new ASTGUI.customObject ;
					}
				}
			}else if ( t[r].toLowerCase().beginsWith("line") ){
				subfield = t[r].afterChar(':'); // subfield
				subfield = subfield.trim();
					if(!p){
					a[catname].push(subfield);
				}else{
					v = subfield.indexOf("=");
					subfield_a = subfield.substring(0,v);//subfield variable
					subfield_b =  subfield.substr(v+1) ;//subfield variable value
					if(a[catname].hasOwnProperty(subfield_a)){
						a[catname][subfield_a] += ',' + subfield_b;
					}else{
						a[catname][subfield_a] = subfield_b;
					}
				}
			}
		}
		return a ;
	};

	if( params.configFile_output ){
		return toJSO( params.configFile_output );
	};

	ASTGUI.Log.Ajax("AJAX Request : reading '" +  params.filename + "'" );

	if( top.sessionData.FileCache.hasOwnProperty(params.filename) &&  top.sessionData.FileCache[params.filename].modified == false){ // if file is in cache and is not modified since
		var s = top.sessionData.FileCache[params.filename].content ;
	}else{
		var s = $.ajax({ url: ASTGUI.paths.rawman+'?action=getconfig&filename='+params.filename, async: false }).responseText;

		top.sessionData.FileCache[params.filename] = {};
		top.sessionData.FileCache[params.filename].content = s;
		top.sessionData.FileCache[params.filename].modified = false;
	}

	if( s.contains('Response: Error') && s.contains('Message: Config file not found') ){
		// return ASTGUI.globals.fnf; // return 'file not found'
		ASTGUI.Log.Error( ' config file(' + params.filename +') not found ' );
		return new ASTGUI.customObject;
	}
	if( s.contains('Response: Error') && s.contains('Message: Permission denied') ){
		ASTGUI.Log.Error('permission denied for reading file ' + params.filename );
		return new ASTGUI.customObject;
	}

	if( params.catlist == 'yes'){
		return toCATLIST(s);
	}
	return toJSO(s);
}; // ( config2json )


var listOfSynActions = function(file){
	// this object should be used if you have 1 to 4 update actions needed to be performed synchronusly.
	// if you have a long list of update actions - use Asynchronus variant of this function  (listOfActions)
	/*	:: Usage ::
		var u = new listOfSynActions('users.conf') ;
		u.new_action('newcat', '6002', '', ''); // create new context
		u.new_action('append', '6002', 'allow', 'all'); // append 'allow=all'
		u.new_action('update', '6002', 'disallow', 'none','all'); // update 'disallow=all' to 'disallow=none'
		u.callActions(); // this is Synchronus function - these actions will be called immediately and the result will be returned
	*/
	//
	if ( !(this instanceof listOfSynActions) ){ return new listOfSynActions(file) ; }
	this.FILE_CONTENT = null ;
	this.params = {} ;
	this.params.action = 'updateconfig';
	this.params.srcfilename = file;
	this.params.dstfilename = file;
	this.FILE_CONTENT = config2json({ filename: file , usf:0 }) ;
	this.actionCount = 0;
};

listOfSynActions.prototype = {
	new_action: function(action, cat, name, value, match){
		var s="";
			switch( action ){
				case 'update':
					if( !this.FILE_CONTENT.hasOwnProperty(cat) ) return s;
					if( this.FILE_CONTENT[cat].indexOfLike(name+'=') == -1 ){
						action = 'append';
					}
					break;
				case 'delete':
					if( !this.FILE_CONTENT.hasOwnProperty(cat) || this.FILE_CONTENT[cat].indexOfLike(name+'=') == -1 ){
						return s;
					}
					break;
				case 'delcat':
					if( !this.FILE_CONTENT.hasOwnProperty(cat) ){
						return s;
					}
					break;
				default: break;
			}

		var cnt = "" + this.actionCount;
		while(cnt.length < 6){ cnt = "0" + cnt; }
		this.params['Action-' + cnt] = action; // jquery takes care of encodeURIComponent(action) 
		this.params['Cat-' + cnt] = cat;
		this.params['Var-' + cnt] = name ;
		this.params['Value-' + cnt] = value ;
		if (match){ this.params['Match-' + cnt] = match; }
		this.actionCount += 1 ;
	},
	clearActions: function(newfile){ // newfile is optional
		var fn = newfile || this.params.srcfilename;
		this.actionCount = 0 ;
		this.params = {} ;
		this.params.action = 'updateconfig';
		this.params.srcfilename = this.params.dstfilename = fn;
		this.FILE_CONTENT = config2json({ filename: fn , usf:0 }) ;
	},
	callActions: function(){
		if(!this.actionCount){ return 'Response: Success'; }
		if(top.sessionData.DEBUG_MODE ){
			ASTGUI.Log.Ajax("AJAX Request : '" + ASTGUI.getObjectPropertiesAsString(this.params) + "'" ); 
		}
		var s = $.ajax({ url: ASTGUI.paths.rawman, data: this.params , async: false });
		
		setTimeout( function(){
			ASTGUI.systemCmd( 'sync' , function(){} )},100); //add sync to fix corruption issue
		return s.responseText;
	}
};

var listOfActions = function(fn){
	/*
	usage: 	var x = new listOfActions('users.conf');
		x.new_action('delcat', '6001', '', ''); // delete context 6001
		x.new_action('renamecat', '6003', '', '6004'); // rename context 6003 to 6004

		x.new_action('newcat', '6002', '', ''); // create new context
		x.new_action('append', '6002', 'allow', 'all'); // append 'allow=all'
		x.new_action('update', '6002', 'disallow', 'none','all'); // update 'disallow=all' to 'disallow=none'
		x.new_action('delete', '6002', 'hasiax', '',''); // delete subfield 'hasiax' (whatever may be the value)
		x.new_action('delete', '6002', 'hassip', '','yes'); // delete subfield 'hassip=yes' 
		.....
		x.callActions(after); // where after is the callback function

	*/
	if ( !(this instanceof listOfActions) ) { return (fn) ? new listOfActions(fn) : new listOfActions() ; }

	this.FILE_CONTENT = null ;
	this.current_batch = 1 ;
	this.current_batch_actionnumber = 0 ;
	this.actions = {};
	if(fn){ 
		this.filename = fn;
		this.FILE_CONTENT = config2json({ filename: fn , usf:0 }) ;
	}
};

listOfActions.prototype = {
	filename: function(fn){
		this.filename = fn;
		this.FILE_CONTENT = config2json({ filename: fn , usf:0 }) ;
	},
	getacn: function(nc){
		return this.current_batch_actionnumber;
	},
	build_action: function(action, count, cat, name, value, match){
		var s="";
			// the update/delete/delcat commands fail in Asterisk 1.6.X/trunk if the corresponding category/variables are not found
			// In Asterisk 1.4 we do not have to do this check
		switch( action ){
			case 'update':
				if( !this.FILE_CONTENT.hasOwnProperty(cat) ) return s;
				if( this.FILE_CONTENT[cat].indexOfLike(name+'=') == -1 ){
					action = 'append';
				}
				break;
			case 'delete':
				if( !this.FILE_CONTENT.hasOwnProperty(cat) || this.FILE_CONTENT[cat].indexOfLike(name+'=') == -1 ){
					return s;
				}
				break;
			case 'delcat':
				if( !this.FILE_CONTENT.hasOwnProperty(cat) ){
					return s;
				}
				break;
			default: break;
			// TODO : handle the case where , a new category is added in 'batch 1' and is deleted in 'batch 2'
			//		the 'delcat' in 'batch 2' would fail cause the switch does not know that the file has been changed after 'batch 1',
			//		and even if we update the FILE_CONTENT after each start_sqreqs() it would still fail cause the batches are already generated by then
			//	we could possibly generate the batches during callActions() and read the file before generating each batch and move this switch inside the batch

			//	This should not be a problem for the time being, but I will fix this issue once i get everything else working with 'asterisk 1.4/1.6.0/trunk'
			//	Note: this is not an issue with listOfSynActions() as clearActions() will take care of updating the file changes
		}
		var cnt = "" + count;
		while(cnt.length < 6)
			cnt = "0" + cnt;
		s += "&Action-" + cnt + "=" + encodeURIComponent(action);
		s += "&Cat-" + cnt + "=" + encodeURIComponent(cat);
		s += "&Var-" + cnt + "=" + encodeURIComponent(name);
		s += "&Value-" + cnt + "=" + encodeURIComponent(value);
		if (match)
			s += "&Match-" + cnt + "=" + encodeURIComponent(match);
		return s;
	},
	addNewChange: function(nc){
		var t = 'act_' + this.current_batch;
		this.actions[t] = (this.current_batch_actionnumber)? this.actions[t] + nc: nc ;
		if( this.current_batch_actionnumber == 5 ){
			this.current_batch++;
			this.current_batch_actionnumber = 0;
		}else{
			this.current_batch_actionnumber++;
		}
	},
	new_action: function(a,b,c,d,e){
		var z = this.getacn();
		var nc = e?this.build_action(a, z, b, c, d, e) : this.build_action(a, z, b, c, d) ;
		if(nc)this.addNewChange(nc);
	},
	callActions: function(callback){
		var ajxs = top.document.getElementById('ajaxstatus') ;
		ajxs.style.display = '';
		if( this.current_batch == 1 && this.current_batch_actionnumber == 0 ){ 
			setTimeout( function(){ ajxs.style.display = 'none'; callback(); }, 500 ) ;
			return;
		}
		var pre_uri = "action=updateconfig&srcfilename=" + encodeURIComponent(this.filename) + "&dstfilename=" + encodeURIComponent(this.filename);
		var treq = this.actions;
		var start_sqreqs = function(st){
			var f = treq[ 'act_' + st ];
			if(f){
				ASTGUI.Log.Ajax("AJAX Request : '" + pre_uri + f + "'" );
				$.ajax({ type: "GET", url: ASTGUI.paths.rawman, data: pre_uri + f , success: function(msg){start_sqreqs(st+1);} });
			}else{
				setTimeout( function(){ ajxs.style.display = 'none'; callback(); }, 500 ) ;
			}
		};
		start_sqreqs(1);
	}
};


(function(){
	var onload_doThese = function(){
		window.onerror = function(err, url, errcode ){ // Log any errors on this page
			var msg = 'ErrorCode / LineNumber : ' + errcode  + '<br /> Error : ' + err + '<br /> Location: ' + url ;
			ASTGUI.Log.Error(msg);
			ASTGUI.dialog.hide();
			if( top.sessionData && top.sessionData.DEBUG_MODE ){ // show alerts only in debug mode
				var alertmsg = 'ErrorCode / LineNumber : ' + errcode  + '\n Error : ' + err + '\n Location: ' + url ;
				ASTGUI.Log.Error(alertmsg);
			}
			if ( jQuery.browser.msie ){ // If critical error in IE , reload entire GUI
				 top.window.location.reload();
 			}
			return true;
		};

		ASTGUI.showToolTips(); // Load any tooltips in this page
		if( window.jQuery ){
			$().ajaxStart( function(){ top.document.getElementById('ajaxstatus').style.display = ''; });
			$().ajaxStop( function(){
				setTimeout( function(){top.document.getElementById('ajaxstatus').style.display = 'none';}, 500 );
			});
		}
		if( window.localajaxinit && (typeof localajaxinit == 'function' ) ){
			if( ASTGUI.cookies.getCookie('configFilesChanged') == 'yes' || ASTGUI.cookies.getCookie('firewalltag') == 'yes'){
				parent.$('#applyChanges_Button').show();
				parent.$('#reloadnotice').show();
			}else{
				parent.$('#applyChanges_Button').hide();
				parent.$('#reloadnotice').hide();
			}
			window.localajaxinit();
		}
	};
	if( window.attachEvent ){
		window.attachEvent( 'onload' , onload_doThese );
	}else if( window.addEventListener ){
		window.addEventListener( 'load' , onload_doThese , false );
	}
})();

function findPosX(obj) {
    var curleft = 0;
    if (obj.offsetParent) {
        while (1) {
            curleft+=obj.offsetLeft;
            if (!obj.offsetParent) {
                break;
            }
            obj=obj.offsetParent;
        }
    } else if (obj.x) {
        curleft+=obj.x;
    }
    return curleft;
}

function findPosY(obj) {
    var curtop = 0;
    if (obj.offsetParent) {
        while (1) {
            curtop+=obj.offsetTop;
            if (!obj.offsetParent) {
                break;
            }
            obj=obj.offsetParent;
        }
    } else if (obj.y) {
        curtop+=obj.y;
    }
    return curtop;
}

function language(LANGUAGE){  

	switch(LANGUAGE){

		case 'English':

		  document.write("<script src='scripts/lang_en.js'><\/script>");
		  document.write("<script src='scripts/tooltip_en.js'><\/script>");
		  language = "English" ;

		  break;
		
		case 'Chinese':

		  document.write("<script src='scripts/lang_cn.js'><\/script>");
		  document.write("<script src='scripts/tooltip_cn.js'><\/script>");
		  language = "Chinese" ; 

		  break;
		
		case 'Persian':

		  document.write("<script src='scripts/lang_farsi.js'><\/script>");
		  document.write("<script src='scripts/tooltip_farsi.js'><\/script>");
		  document.write("<link href='stylesheets/rtlstyle.css' media='all' rel='Stylesheet' type='text/css' />")
		  language = "Persian" ; 

		  break;

		case 'Vietnamese':

		  document.write("<script src='scripts/lang_vn.js'><\/script>");
		  document.write("<script src='scripts/tooltip_vn.js'><\/script>");
		  language = "Vietnamese" ;

		  break;
		
		case 'Arabic':

		  document.write("<script src='scripts/lang_ar.js'><\/script>");
		  document.write("<script src='scripts/tooltip_ar.js'><\/script>");
		  document.write("<link href='stylesheets/rtlstyle.css' media='all' rel='Stylesheet' type='text/css' />")
		  language = "Arabic" ; 

		  break;
		  
		case 'Portuguese':
		
		  document.write("<script src='scripts/lang_br.js'><\/script>");
		  document.write("<script src='scripts/tooltip_br.js'><\/script>");
		  language = "Portuguese" ; 
		  break;
		  
		case 'Italy':

		  document.write("<script src='scripts/lang_it.js'><\/script>");
		  document.write("<script src='scripts/tooltip_it.js'><\/script>");
		  language = "Italy" ; 

		  break;
		  
		case 'French':

		  document.write("<script src='scripts/lang_fr.js'><\/script>");
		  document.write("<script src='scripts/tooltip_fr.js'><\/script>");
		  language = "French" ; 

		  break;
		  
		case 'Spanish':

		  document.write("<script src='scripts/lang_es.js'><\/script>");
		  document.write("<script src='scripts/tooltip_es.js'><\/script>");
		  language = "Spanish" ; 

		  break;
		  
		case 'Russian':

		  document.write("<script src='scripts/lang_ru.js'><\/script>");
		  document.write("<script src='scripts/tooltip_ru.js'><\/script>");
		  language = "Russian" ; 

		  break;

		default:

		  document.write("<script src='scripts/lang_en.js'><\/script>"); 
		  document.write("<script src='scripts/tooltip_en.js'><\/script>");
		  language = "English" ;
		  break;

	}	
}

function check_patternonfields(fields,msg){

	// for checking validity of field contents before form submitting
	for (var i=0; i < fields.length; i++){
		var field = fields[i];
		if(typeof field =='string'){
			field = _$(field); 
		}
		var x = field.value.trim();
		if( (isNulls(x))){
			if( field.getAttributeNode('pattern').value && !check_pattern(field.getAttributeNode('pattern').value , field.value)   ){
				if(msg){
					ASTGUI.highlightField(field, msg);
				}else{
	           		ASTGUI.highlightField(field, Invalidcharacters);
				}
				return false;
			}
		}
	}

	return true;

}

function isNulls(a){
	if(a=="undefined") return false;
	if(a==null) return false;
	if(a=="NaN") return false;
	a=trim(a);
	if(a.length<1)return false;
	return true;
}

function trim(str){ 
	return str.replace(/(^\s*)|(\s*$)/g, "");
}

function ltrim(str){ 
	return str.replace(/(^\s*)/g,"");
}

function rtrim(str){ 
	return str.replace(/(\s*$)/g,"");
}



function check_pattern(pattern, text){
	if(isNulls(text)){
		if (text.search(pattern) == -1)
			return false;
		else
			return true;
	}
	return false;
}
function isMac(strMac) {
	if(strMac.length!=12) return false;
	if(/[^a-fA-F0-9]/.test(strMac)) return false;
	return true;
}
function isMac2(strMac) {
	if(strMac.length!=17) return false;
	var re = /[a-fA-F\d]{2}:[a-fA-F\d]{2}:[a-fA-F\d]{2}:[a-fA-F\d]{2}:[a-fA-F\d]{2}:[a-fA-F\d]{2}/; 
	if(!re.test(strMac)) return false;
	return true;
}
function isIP(strIP) {
	if (!isNulls(strIP)) return false;
	var re=/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/; 
	if(re.test(strIP)){
		if( RegExp.$1 <256 && RegExp.$2<256 && RegExp.$3<256 && RegExp.$4<256 && RegExp.$1 !=0 &&  RegExp.$1 !=127 &&  RegExp.$1<224 )
		 return true;
	}
	return false;
}
function isIPMask(strIP) {
	var obj=strIP; 
    var exp=/^(254|252|248|240|224|192|128|0)\.0\.0\.0|255\.(254|252|248|240|224|192|128|0)\.0\.0|255\.255\.(254|252|248|240|224|192|128|0)\.0|255\.255\.255\.(255|254|252|248|240|224|192|128|0)$/; 
   	var reg = obj.match(exp); 
    if(reg==null){ 
       return false; 
    }else{ 
       return true; 
    } 
}
function randomPassword(){  
		var seed = new Array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','P','Q','R','S','T','U','V','W','X','Y','Z',  
							 'a','b','c','d','e','f','g','h','i','j','k','m','n','p','Q','r','s','t','u','v','w','x','y','z',
							 '2','3','4','5','6','7','8','9',
							 '!','@','#','%','*','-','_'
							 );//
		seedlength = seed.length;//  
		var createPassword = '';  
		for (i=0;i<10;i++) {
			j = Math.floor(Math.random()*seedlength);  
			createPassword += seed[j];  
		}  		 
		return createPassword;  
 
}
function isPort(port){
	if ( typeof port == 'string'){ port = _$(port) ; }
	if(!check_pattern('^[0-9]*$', port.value)){
		ASTGUI.highlightField(port , PortNum);
		return false;
	}
	if(!port.value.isValueInBetween(1,65535)){
		ASTGUI.highlightField(port , OutBoundProxyPort);
		return false;
	}
	return true;
}

function isRTPPort(port){
	if ( typeof port == 'string'){ port = _$(port) ; }
	if(!check_pattern('^[0-9]*$', port.value)){
		ASTGUI.highlightField(port , PortNum);
		return false;
	}
	if(!port.value.isValueInBetween(10000,65535)){
		ASTGUI.highlightField(port , RTPProxyPort);
		return false;
	}
	return true;
}

var asterisk_guifbt2 = 300; // Feedback msg time
var exten_limited = 100;
var pb_limit = 500;
var vpn_limited = 10;
var fwrules_limit = 40;
function checkSameNetMask2(value1,value2,netmask,netmask2){
	var num1=Array();
	var num2=Array();		
 	var ip1 = new Array();
 	var ip2 = new Array();
	var nm = new Array();
 	var nm2 = new Array();
	ip1 = value1.split(".");
 	ip2 = value2.split(".");
	nm = netmask.split(".");
	nm2 = netmask2.split(".");
	num1=nm[0]+nm[1]+nm[2]+nm[3];
	num2=nm2[0]+nm2[1]+nm2[2]+nm2[3];
	if(num1>num2)
		nm=nm2;
	else
		nm2=nm;
	var ip1_2s = "";
	var ip2_2s = "";
 	var inm2_1s = "";
	var inm2_2s = "";
	var index = 0;
	for ( index = 0 ; index<4 ; index++ ){
 		var ip_1 = new Array();
 		var ip_2 = new Array();
 		var n_m1 = new Array();
 		var n_m2 = new Array();
 		ip_1 = parseInt(ip1[index]).toString(2);
 		ip_2 = parseInt(ip2[index]).toString(2);
 		n_m1 = parseInt(nm[index]).toString(2);
  		n_m2 = parseInt(nm2[index]).toString(2);
 	 	var tindex;
 	 	for( tindex = 0; tindex<(8 - ip_1.length) ; tindex++){
 	 		ip1_2s +="0";
 	 	}
	  		ip1_2s += ip_1;
 		for( tindex = 0; tindex<(8 - ip_2.length) ; tindex++){
 	 		ip2_2s +="0";
 	 	}
	 	ip2_2s += ip_2;
 	 for( tindex = 0; tindex<(8 - n_m1.length) ; tindex++){
 	  inm2_1s +="0";
 	 }
 	 inm2_1s += n_m1; 
  
 	  for( tindex = 0; tindex<(8 - n_m2.length) ; tindex++)
 	 {
  	 inm2_2s +="0";
 	 }
 	 inm2_2s += n_m2; 
  
	 }
 	var len = inm2_1s.length;
	var ip_12 = new Array();
	var ip_22 = new Array();
	var n_m_21 = new Array();
	var n_m_22 = new Array();
 	ip_12 = ip1_2s.split("");
	ip_22 = ip2_2s.split("");
	n_m_21 = inm2_1s.split("");
	n_m_22 = inm2_2s.split("");
	var p1=new Array();
	var p2=new Array(); 
	for ( index = 0 ; index < len ; index++ ){ 
 		p1=n_m_21[index]&ip_12[index];
 		p2=n_m_22[index]&ip_22[index];
 		if(p1!=p2)
			return false;
	}
	 return true;
	}
	
	
	
function checkSameNetMask(value1,value2,netmask)
	{
	 var ip1 = new Array();
	 var ip2 = new Array();
	 var nm = new Array();
	 ip1 = value1.split(".");
	 ip2 = value2.split(".");
	 nm = netmask.split(".");
	 var ip1_2s = "";
	 var ip2_2s = "";
	 var inm2s = "";
	 var index = 0;
	 for ( index = 0 ; index<4 ; index++ )
	 {
	  var ip_1 = new Array();
	  var ip_2 = new Array();
	  var n_m = new Array();
	  ip_1 = parseInt(ip1[index]).toString(2);
	  ip_2 = parseInt(ip2[index]).toString(2);
	  n_m = parseInt(nm[index]).toString(2);
	  var tindex;
	  for( tindex = 0; tindex<(8 - ip_1.length) ; tindex++){
	   ip1_2s +="0";
	  }
	  ip1_2s += ip_1;
	  for( tindex = 0; tindex<(8 - ip_2.length) ; tindex++){
	   ip2_2s +="0";
	  }
	  ip2_2s += ip_2;
	  for( tindex = 0; tindex<(8 - n_m.length) ; tindex++){
	   inm2s +="0";
	  }
	  inm2s += n_m; 
	 }
	 var len = inm2s.length;
	 var ip_12 = new Array();
	 var ip_22 = new Array();
	 var n_m_2 = new Array();
	 ip_12 = ip1_2s.split("");
	 ip_22 = ip2_2s.split("");
	 n_m_2 = inm2s.split("");
	 for ( index = 0 ; index < len ; index++ ){
	 	if(n_m_2[index] == "1"){
			if(ip_12[index] != ip_22[index]){
			return false;
	   }
	  }
	 }
 	 return true;
}

function IPbs(value1,value2,netmask,netmask2)
{
	//value1>value2 return true
	 var num1=Array();
	 var num2=Array();	
	 var ip1 = new Array();
	 var ip2 = new Array();
	 var nm = new Array();
	 var nm2 = new Array();
	 ip1 = value1.split(".");
	 ip2 = value2.split(".");
	 nm = netmask.split(".");
	 nm2 = netmask2.split(".");
	 num1=nm[0]+nm[1]+nm[2]+nm[3];
	 num2=nm2[0]+nm2[1]+nm2[2]+nm2[3];
	 if(num1>num2)
	 	nm=nm2;
	 else
	 	nm2=nm;	 
	 var ip1_2s = "";
	 var ip2_2s = "";
	 var inm2_1s = "";
	 var inm2_2s = "";
	 var index = 0;
	 for ( index = 0 ; index<4 ; index++ ){
	  var ip_1 = new Array();
	  var ip_2 = new Array();
	  var n_m1 = new Array();
	  var n_m2 = new Array();
	  ip_1 = parseInt(ip1[index]).toString(2);
	  ip_2 = parseInt(ip2[index]).toString(2);
	  n_m1 = parseInt(nm[index]).toString(2);
	  n_m2 = parseInt(nm2[index]).toString(2);
	  var tindex;
	  for( tindex = 0; tindex<(8 - ip_1.length) ; tindex++){
	  	ip1_2s +="0";
	  }
	  ip1_2s += ip_1;
	  for( tindex = 0; tindex<(8 - ip_2.length) ; tindex++){
	  	ip2_2s +="0";
	  }
	  ip2_2s += ip_2;
	  for( tindex = 0; tindex<(8 - n_m1.length) ; tindex++){
	  	inm2_1s +="0";
	  }
	  inm2_1s += n_m1; 
	  for( tindex = 0; tindex<(8 - n_m2.length) ; tindex++){
	  	inm2_2s +="0";
	  }
	  inm2_2s += n_m2;
	 }
	 var len = inm2_1s.length;
	 var ip_12 = new Array();
	 var ip_22 = new Array();
	 var n_m_21 = new Array();
	 var n_m_22 = new Array();
	 ip_12 = ip1_2s.split("");
	 ip_22 = ip2_2s.split("");
	 n_m_21 = inm2_1s.split("");
	 n_m_22 = inm2_2s.split("");
	 var p1=new Array();
	 var p2=new Array(); 
	 var p12=new Array();
	 var P22=new Array();
	 for ( index = 0 ; index < len ; index++ ){
		 if(n_m_21[index]==0)
			n_m_21[index]=1;
		  else
			n_m_21[index]=0;
		 if(n_m_22[index]==0)
			n_m_22[index]=1;
		 else
			n_m_22[index]=0;
		 p1[index]=n_m_21[index]&&ip_12[index];
		 p2[index]=n_m_22[index]&&ip_22[index];
	}
	 p12=p1.join("");
	 p22=p2.join("");
	 p12=parseInt(p12);
	 p22=parseInt(p22);
	 if(p12>p22)
	 	return true;
	 return false;
}

function subscreenload(src){
	ASTGUI.feedback( { msg:'' } );
	window.location.href = src + "?_v=" + top.branding['HideVersion'];
}
 
 
 

